<?php if(! defined ( 'BASEPATH' )) exit ( 'No direct script access allowed' );

if(file_exists ( APPPATH . '/models/saas_cron.php' ))
	require_once (APPPATH . '/models/saas_cron.php');

class Cron_model extends CI_Model {

	function __construct()
	{
		$this->load->model ( 'entity' );
		parent::__construct ();
	}

	private $budget_mail_list = array ();

	public function get_next_number($entity_id)
	{
		$next_num = '0001';
		
		$this->db->select ( 'invoice_number' );
		$this->db->from ( 'invoice' );
		$this->db->where ( array (
			'entity_id' => $entity_id 
		) );
		$this->db->order_by ( 'invoice_id', 'desc' );
		$this->db->limit ( 1 );
		$query = $this->db->get ();
		
		$return = $query->row_array ();
		
		if($return)
		{
			$pattern = '/[0-9]+$/';
			if(preg_match ( $pattern, $return ['invoice_number'], $matches ))
			{
				$next_num = str_pad ( $matches [0] + 1, strlen ( $matches [0] ), 0, STR_PAD_LEFT );
				$next_num = preg_replace ( $pattern, $next_num, $return ['invoice_number'] );
			} else
			{
				$next_num = $return ['last'] . '1';
			}
		}
		
		return $next_num;
	}

	public function get_user_details($id = NULL, $data = array())
	{
		// prepare require data
		$where = $data;
		if($id)
		{
			$where ['user_id'] = $id;
		}
		$where ['entity_id'] = $this->ot_app->get ( 'entity_id' );
		
		$this->db->select ( 'user_id, email, first_name, last_name, user_role, department, is_active, user_image, time_zone_code' );
		$this->db->from ( 'entity_users' );
		$this->db->where ( $where );
		$query = $this->db->get ();
		
		$user = $query->row_array ();
		
		return $user;
	}

	public function get_entities($where = array())
	{
		$this->db->select ( 'ea.entity_id, ea.company_name, concat(eu.first_name," ",eu.last_name) as user_name, eu.email, eu.user_image, e.entity_logo, es.time_zone_code, es.date_format, es.time_format, es.period_format, es.time_stamp_req, es.time_sheet_approval, es.modify_billable, es.time_round_to, es.fiscal_year_month, es.currency_code, es.number_format, cu.currency_symbol, es.account_owner_id, es.start_week_on, ea.domain_url', false );
		
		$this->db->from ( 'entity_setting AS es' );
		$this->db->join ( 'currency AS cu', 'es.currency_code=cu.currency_code', 'inner' );
		$this->db->join ( 'entity_users AS eu', 'eu.user_id=es.account_owner_id', 'inner' );
		$this->db->join ( 'entity_accounts AS ea', 'eu.entity_id=ea.entity_id', 'inner' );
		$this->db->join ( 'entity AS e', 'e.entity_id=es.entity_id', 'inner' );
		if ($where) {
			$this->db->where($where, NULL, FALSE);	
		}
		$query = $this->db->get ();
		
		$result = $query->result_array ();
		
		if(! $result)
			return $result;
		$data = array ();
		foreach($result as $key=>$row)
		{
			$result [$key] ['entity_logo_disp'] = base_url () . 'files/photo/nocompany.jpg';
			if(! empty ( $result [$key] ['entity_logo'] ))
			{
				$file = pathinfo ( $result [$key] ['entity_logo'] );
				if(file_exists ( 'uploads/' . $result [$key] ['entity_id'] . '/' . $file ['filename'] . '_160.' . $file ['extension'] ))
					$result [$key] ['entity_logo_disp'] = base_url () . 'uploads/' . $result [$key] ['entity_id'] . '/' . $file ['filename'] . '_160.' . $file ['extension'];
			}
			
			$data [$result [$key] ['entity_id']] = $result [$key];
		}
		return $data;
	}

	public function recurring_invoice()
	{
		$entities = $this->get_entities ('domain_url is not null');
//		$entities = $this->get_entities ('ea.entity_id = 4');

		$this->lang->load ( 'invoices' );
		if($entities)
		{
			foreach($entities as $entity)
			{
				$timezone = ($entity ['time_zone_code']) ? $entity ['time_zone_code'] : 'UTC';
				$timestamp = strtotime ( date ( 'Y-m-d H:i:s' ) );
				$daylight_saving = date ( 'I' );
				$local_timestamp = gmt_to_local ( $timestamp, $timezone, $daylight_saving );
				$today_date = date ( 'Y-m-d', $local_timestamp );
				$cur_time = date ( 'Y-m-d H:i:s', $local_timestamp );
				
				/* get recurring invoice */
				$this->db->select ( '*' );
				$this->db->from ( 'invoice' );
				$this->db->where ( array (
					'entity_id' => $entity ['entity_id'],
					'recurring_mode !=' => '0',
					'recurring_next_inv_date' => $today_date,
					'status !=' => 'd' 
				) );
				$query = $this->db->get ();
				
				$rec_inv = $query->result_array ();
				
				if($rec_inv)
				{
					foreach($rec_inv as $key=>$data)
					{
						$old_inv_id = $data ['invoice_id'];
						
						// reset values for new invoice
						unset ( $data ['invoice_id'] );
						$data ['payment_amount'] = 0;
						$data ['status'] = 'd';
						$data ['invoice_number'] = $this->get_next_number ( $entity ['entity_id'] );
						unset ( $data ['last_updated_by'] );
						$data ['last_updated_date'] = $cur_time;
											

						if (!empty($data['import_config'])) {

							$this->load->model('invoices','',false,'A');
							$post_data = array('entity_id' => $entity ['entity_id']);
							$conf = JSON_decode($data['import_config']);

							// if ($data['date_filter_type']=='CU') {
								$data['date_filter_type']=='CU';
								$diff_day = (strtotime($data['recurring_next_inv_date'])-strtotime($data['invoice_date']))/(24*60*60) - 1;
								$data['from_date'] = $post_data['start_date'] = date('Y-m-d', strtotime("+1 day",(strtotime($data['invoice_date']))));
								$data['to_date'] = $post_data['finish_date'] = date('Y-m-d', strtotime("+$diff_day day",(strtotime($data['from_date']))));
							/* } else if ($data['date_filter_type']!='ALL'){
								$dates = get_date_filters($data['date_filter_type']);
							}*/

							$post_data['project_ids'] = $conf->ids;
							if (isset($conf->hours)) {
								$post_data['invoice_hours'] = 1;
								$group_field = array('project','tasktype', 'date', 'activity', 'member');
								foreach ($conf->hours as $conf_key=>$conf_val) {
									$post_data['group_by'][$group_field [$conf_key]] = $conf_val;
								}
							}
							if (isset($conf->expenses)) {
								$post_data['invoice_expenses'] = 1;
								$post_data['detail_expenses'] = $conf->expenses;
							}
							$data['amount'] = 0;
							$invoice_items = $this->invoices->get_import_details($post_data);
							if ($invoice_items) {
								foreach($invoice_items as $in_key=>$inv_itm)
								{
									$invoice_items [$in_key]['amount'] = $inv_itm['quantity'] * $inv_itm['rate'];
									$data['amount'] += $invoice_items [$in_key]['amount'];
								}
								$data['discount_amount'] = $data['discount_percentage']?($data['amount']*($data['discount_percentage']/100)):$data['discount_amount'];
								$data['amount'] -= $data['discount_amount'];
								$data['amount'] = ($data['amount']>0)?$data['amount']:0;
								$this->db->insert_batch ( 'invoice_items', $invoice_items );
							}
						} else {
							// get invoice items
							$this->db->select ( '*' );
							$this->db->from ( 'invoice_items' );
							$this->db->where ( 'invoice_id', $old_inv_id );
							$query = $this->db->get ();
							$invoice_items = $query->result_array ();
						}

						// get due date diff from invoice date
						$data ['due_date'] = $this->calculate_date ( $data ['invoice_date'], $data ['due_date'], $today_date, $data ['due_date_mode'] );
						
						// get recurring date diff from invoice date
						$data ['recurring_next_inv_date'] = $this->calculate_date ( $data ['invoice_date'], $data ['recurring_next_inv_date'], $today_date, $data ['recurring_mode'] );	
						$data ['invoice_date'] = $today_date;
						$data['subject' ] 		= 'Imported between '.$data['from_date'].' to '.$data['to_date'];

						$this->db->insert ( 'invoice', $data );
						$data ['invoice_id'] = $new_inv_id = $this->db->insert_id ();

						if($invoice_items)
						{
							foreach($invoice_items as $in_key=>$inv_itm)
							{
								$invoice_items [$in_key] ['invoice_id'] = $new_inv_id;
								unset ( $invoice_items [$in_key] ['invoice_item_id'] );
								// $this->db->insert('invoice_items', $inv_itm);
							}
							$this->db->insert_batch ( 'invoice_items', $invoice_items );
						}
						
						// write the recurring invoice activity
						if($data ['created_by'])
						{
							$user_data = $this->get_user_details ( $data ['created_by'] );
							$currency_symbol = get_currency ( $data ['currency_code'] );
							$a_notes = $user_data ['first_name'] . ' ' . $user_data ['last_name'] . 'created Recurring Invoice #' . $data ['invoice_number'] . ' (' . $currency_symbol . ' ' . $data ['amount'] . ')';
							$act_data = array (
								'user_id' => $data ['created_by'],
								'entity_id' => $entity ['entity_id'],
								'a_date' => $today_date,
								'user_ip' => $_SERVER ['REMOTE_ADDR'],
								'a_mode' => 'IN',
								'a_id' => $new_inv_id,
								'a_notes' => $a_notes 
							);
							$this->db->insert ( 'user_activity', $act_data );
						}
						
						// mail to client
						if($data ['recurring_auto'])
						{
							// get contact details
							$this->db->select ( 'cc.client_contact_id, cc.client_id, c.client_name, cc.name, cc.title, a.address_id, a.email, a.workphone, a.mobile' );
							$this->db->from ( 'client AS c' );
							$this->db->join ( 'client_contact AS cc', 'c.client_id = cc.client_id' );
							$this->db->join ( 'address AS a', 'cc.address_id = a.address_id' );
							$this->db->where ( array (
								'cc.client_contact_id' => $data ['client_contact_id'],
								'c.entity_id' => $data ['entity_id'] 
							) );
							$query = $this->db->get ();
							
							$data ['contacts'] = $query->result_array ();
							$data ['company'] = $entity;
							$data ['details'] = $invoice_items;
							$data ['attachment'] = $this->pdf ( $data );
							$this->sendmail ( $data );
						}
					}
				}
			}
		}
	}

	public function client_contacts($invoice_id, $entity_id)
	{
		$select = 'concat(cc.name, "<",a.email,">") AS email, inv.client_contact_id as inv_contact_id, cc.client_contact_id';
		$this->db->select ( $select, false );
		$this->db->from ( 'invoice AS inv' );
		$this->db->join ( 'client_contact AS cc', 'cc.client_id = inv.client_id' );
		$this->db->join ( 'address AS a', 'a.address_id = cc.address_id' );
		
		$this->db->where ( array (
			'inv.entity_id' => $entity_id,
			'inv.invoice_id' => $invoice_id 
		) );
		$this->db->order_by ( 'inv.invoice_id' );
		
		$query = $this->db->get ();
		$emails = $query->result_array ();
		
		$cc = $to = $result = array ();
		foreach($emails as $row)
		{
			if($row ['inv_contact_id'] == $row ['client_contact_id'])
				$to [] = $row ['email'];
			else
				$cc [] = $row ['email'];
		}
		$result ['to'] = implode ( ', ', $to );
		$result ['cc'] = ($cc) ? implode ( ', ', $cc ) : '';
		return $result;
	}

	private function sendmail($data)
	{
		$result = $this->client_contacts ( $data ['invoice_id'], $data ['entity_id'] );
		$details = $data ['details'];
		
		$company = $data ['company'];
		$data ['client_address'] = $data ['address'];
		$data ['client_name'] = $data ['contacts'] [0] ['client_name'];
		$data ['contact_name'] = $data ['contacts'] [0] ['name'];
		$data ['admin_name'] = $company ['user_name'];
		$data ['admin_email'] = $company ['email'];
		$data ['company_name'] = $company ['company_name'];
		$data ['company_url'] = site_url ();
		$data ['total'] = get_currency ( $company ['currency_code'] ) . ' ' . $data ['amount'];
		$email_template = lang ( 'INVOICE_MAIL_TEMPLATE' );
		
		$pattern = "/\%(.*?)\%/";
		if(preg_match_all ( $pattern, $email_template, $matches ))
		{
			foreach($matches [1] as $tag)
			{
				if(isset ( $tag ))
					$email_template = str_replace ( '%' . $tag . '%', $data [$tag], $email_template );
			}
		}
		$data ['message'] = $email_template;
		$data ['status'] = 's';
		
		$email_subject = sprintf ( lang ( "INVOICE_MAIL_SUBJECT" ), $company ['company_name'], $data ['invoice_number'] );
		;
		
		$config ['mimetype'] = 'pdf';
		$config ['mailtype'] = 'html';
		$this->load->library ( 'email', $config );
		$this->email->from ( $this->config->item ( 'smtp_user' ), $this->config->item ( 'domain_name' ) );
		$this->email->to ( $result ['to'] );
		$this->email->cc ( $result ['cc'] );
		$this->email->subject ( $email_subject );
		$this->email->message ( nl2br ( $data ['message'] ) );
		$this->email->attach ( $data ['attachment'] ['filepath'] );
		if(! $this->email->send ())
		{
			unlink ( $data ['attachment'] ['filepath'] );
			return false;
		}
		unlink ( $data ['attachment'] ['filepath'] );
		$where = array (
			'entity_id' => $data ['entity_id'],
			'invoice_id' => $data ['invoice_id'] 
		);
		$this->db->where ( $where );
		$this->db->update ( 'invoice', array (
			'status' => $data ['status'] 
		) );
		
		return true;
	}

	public function pdf($data)
	{
		require_once (APPPATH . 'third_party/html2pdf/html2pdf.class.php');
		$this->load->library ( 'parser' );
		$id = $data ['invoice_id'];
		$company = $data ['company'];
		unset ( $data ['company'] );
		
		if(! $data || ! $company)
			return false;
		
		$attachment_name = 'Invoice_' . $data ['invoice_number'] . '.pdf';
		$file_path = 'uploads/' . $attachment_name;
		
		$data ['entity'] = $company ['company_name'];
		$data ['logo'] = $company ['entity_logo_disp'];
		$data ['email'] = $company ['email'];
		
		foreach($data ['contacts'] [0] as $key=>$value)
		{
			if($key == 'email')
				$data ['contacts'] [0] [$key] = ($value != '') ? 'Email : ' . $value : '';
			if($key == 'workphone')
				$data ['contacts'] [0] [$key] = ($value != '') ? 'Phone : ' . $value : '';
			if($key == 'mobile')
				$data ['contacts'] [0] [$key] = ($value != '') ? 'Mobile : ' . $value : '';
		}
		$data ['contact_name'] = $data ['contacts'] [0] ['name'];
		// prepare discount amount
		$data ['discount'] = array ();
		if($data ['discount_percentage'] > 0 && $data ['discount_amount'])
			$data ['discount'] [0] = array (
				'dis_title' => '- Discount (' . $data ['discount_percentage'] . '%)',
				'dis_amount' => sprintf ( '%0.2f', $data ['discount_amount'] ) 
			);
		if(! $data ['discount_percentage'] && $data ['discount_amount'])
			$data ['discount'] [0] = array (
				'dis_title' => '- Discount',
				'dis_amount' => sprintf ( '%0.2f', $data ['discount_amount'] ) 
			);
			// payment amount
		$data ['payment'] = array ();
		$data ['total'] = array ();
		$data ['inv_notes'] = array ();
		$data ['inv_subject'] = array ();
		if($data ['subject'] != '')
		{
			if(strpos ( $data ['subject'], 'imported' ) > 0)
			{
				$data ['subject'] = 'Invoice generated for ' . str_replace ( 'are imported', '', $data ['subject'] );
			}
			$data ['inv_subject'] [0] = array (
				'subject' => $data ['subject'] 
			);
		}
		if($data ['notes'] != '')
			$data ['inv_notes'] [0] = array (
				'notes' => $data ['notes'] 
			);
		if($data ['payment_amount'] > 0)
		{
			$data ['payment'] [0] = array (
				'total_amount' => sprintf ( '%0.2f', $data ['amount'] ),
				'paid_amount' => sprintf ( '%0.2f', $data ['payment_amount'] ),
				'due_amount' => sprintf ( '%0.2f', $data ['amount'] - $data ['payment_amount'] ) 
			);
		} else
			$data ['total'] [0] = array (
				'final_total' => sprintf ( '%0.2f', $data ['amount'] ) 
			);
		unset ( $data ['amount'] );
		unset ( $data ['subject'] );
		unset ( $data ['notes'] );
		$data ['tax'] = array ();
		for($j = 1; $j < 4; $j ++)
		{
			if($data ['tax' . $j . '_amount'])
			{
				$data ['tax'] [$j] ['tax_name'] = '+ ' . $data ['tax' . $j . '_name'] . ' (' . $data ['tax' . $j . '_percentage'] . '%)';
				$data ['tax'] [$j] ['tax_amount'] = sprintf ( '%0.2f', $data ['tax' . $j . '_amount'] );
				unset ( $data ['tax' . $j . '_name'] );
				unset ( $data ['tax' . $j . '_percentage'] );
				unset ( $data ['tax' . $j . '_amount'] );
			}
		}
		$data ['title'] = $data ['invoice_id'] == 0 ? 'ESTIMATE' : 'INVOICE';
		$data ['number'] = $data ['invoice_number'];
		$data ['date'] = 'Date : ' . date ( 'd/m/Y', strtotime ( $data ['invoice_date'] ) );
		$data ['due_date'] = 'Due Date : ' . date ( 'd/m/Y', strtotime ( $data ['due_date'] ) );
		$data ['next_date'] = ($data ['recurring_mode'] != '0' && $data ['recurring_mode'] != '') ? 'Next Invoice Date : ' . date ( 'd/m/Y', strtotime ( $data ['recurring_next_inv_date'] ) ) : '';
		$enabled_tax = array ();
		$subtotal = 0;
		/*
		 * foreach ($data['details'] as $k => $detail){ // alternative colors for table row if($detail['serial_no']%2 == 0) $data['details'][$k]['serial_css'] = 'even'; else $data['details'][$k]['serial_css'] = 'odd'; // to display enabled tax if ($detail['is_tax1']) { $enabled_tax[] = "1"; } if ($detail['is_tax2']) { $enabled_tax[] = "2"; } if ($detail['is_tax3']) { $enabled_tax[] = "3"; } if(isset($enabled_tax) && !empty($enabled_tax)) { $data['details'][$k]['tax_active'] = '('.implode (",", $enabled_tax).')'; unset($enabled_tax); } $data['details'][$k]['amount'] = sprintf('%0.2f', $data['details'][$k]['amount']); $subtotal += $data['details'][$k]['amount']; } $data['subtotal'] = sprintf('%0.2f', $subtotal);
		 */
		// $data['currency'] = html_entity_decode(get_currency($data['currency_code']));
		
		$inv_row = $this->entity->get_active_inv_template ();
		$inv_tmp = (! empty ( $inv_row ['inv_template'] ) ? $inv_row ['inv_template'] : 'default');
		$content = $this->parser->parse ( 'invoice_templates/' . $inv_tmp, $data, true );
		
		// $content = $this->parser->parse('estimate/pdf_template', $data,true);
		
		$pattern = "/\{(.*?)\}/";
		while(preg_match ( $pattern, $content ))
		{
			$content = preg_replace ( $pattern, "", $content );
		}
		// echo $content;exit;
		$html2pdf = new HTML2PDF ( 'P', 'A4', 'en', true, 'UTF-8', array (
			7,
			7,
			10,
			10 
		) );
		
		$html2pdf->setDefaultFont ( 'helvetica' );
		
		$html2pdf->WriteHTML ( $content );
		
		// if (!$preview) //save
		$html2pdf->Output ( $file_path, 'F' );
		
		$attachments = array (
			'url' => base_url ( $file_path ),
			'file' => $attachment_name,
			'filepath' => FCPATH . $file_path 
		);
		
		return $attachments;
	}

	public function calculate_date($date1, $date2, $cur_date, $mode)
	{
		$mode_array = array (
			'M1' => '+1 month',
			'M2' => '+2 month',
			'M3' => '+3 month',
			'M4' => '+4 month',
			'M6' => '+6 month',
			'M12' => '+12 month' 
		);
		
		$new_date = $cur_date;
		
		if(in_array ( $mode, array_keys ( $mode_array ) ))
		{
			$new_date = date ( 'Y-m-d', strtotime ( $mode_array [$mode], strtotime ( $cur_date ) ) );
		} else if($mode == 'EMF')
		{
			$new_date = date ( 'Y-m-d', strtotime ( '+1 month', strtotime ( $date2 ) ) );
			$new_date = date ( 'Y-m-01', strtotime ( $new_date ) );
		} else if($mode == 'EML')
		{
			$new_date = date ( 'Y-m-d', strtotime ( '+1 month', strtotime ( $date2 ) ) );
			$new_date = date ( 'Y-m-t', strtotime ( $new_date ) );
		} else
		{
			$diff_date = strtotime ( $date2 ) - strtotime ( date ( 'Y-m-d', strtotime ( $date1 ) ) );
			$diff_days = ceil ( $diff_date / (60 * 60 * 24) );
			
			$new_date = (! $diff_days) ? $cur_date : date ( 'Y-m-d', strtotime ( $diff_days . ' days', strtotime ( $cur_date ) ) );
		}
		
		return $new_date;
	}

	public function force_close_old_timesheet($utc_time)
	{
		$timestamp = strtotime ( $utc_time );
		$daylight_saving = date ( 'I' );
		
		$this->db->select ( 'es.time_zone_code, es.entity_id' );
		$this->db->from ( 'entity as e' );
		$this->db->join ( 'entity_setting as es', 'e.entity_id = es.entity_id' );
		$query = $this->db->get ();
		$entities = $query->result_array ();
		
		if($entities)
		{
			foreach($entities as $entity)
			{
				$timestamp = strtotime ( $utc_time );
				$daylight_saving = date ( 'I' );
				$local_timestamp = gmt_to_local ( $timestamp, $entity ['time_zone_code'], $daylight_saving );
				$cur_date = date ( 'Y-m-d', $local_timestamp );
				$cur_time = date ( 'Y-m-d H:i:s', $local_timestamp );
				
				$this->db->select ( 'time_sheet_id' );
				$this->db->from ( 'time_sheet' );
				$this->db->where ( array (
					'is_progress' => 1,
					'entry_date <' => $cur_date,
					'entity_id' => $entity ['entity_id'] 
				) );
				$query = $this->db->get ();
				$ts_array = $query->result_array ();
				if($ts_array)
				{
					$ts_array = array_key_index ( $ts_array, 'time_sheet_id' );
					$ts_ids = array_keys ( $ts_array );
					$this->db->set ( 'to_time', 'from_time', false );
					$this->db->where_in ( 'time_sheet_id', $ts_ids );
					$this->db->where ( array (
						'is_progress' => 1 
					) );
					$this->db->update ( 'time_sheet_detail', array (
						'is_progress' => 0,
						'hours' => 0,
						'updated_date' => $cur_time 
					) );
					$this->db->where_in ( 'time_sheet_id', $ts_ids );
					$this->db->where ( array (
						'is_progress' => 1 
					) );
					$this->db->update ( 'time_sheet', array (
						'is_progress' => 0,
						'last_updated_date' => $utc_time 
					) );
				}
			}
		}
		
		return true;
	}

	public function reset_timesheet($time_zone, $utc_time)
	{
		$timestamp = strtotime ( $utc_time );
		$daylight_saving = date ( 'I' );
		$local_timestamp = gmt_to_local ( $timestamp, $time_zone, $daylight_saving );
		$entry_time = date ( 'Y-m-d H:i:s', $local_timestamp );
		$cur_date = date ( 'Y-m-d', $local_timestamp );
		
		$where = array (
			't.is_progress' => 1,
			'eu.time_zone_code' => $time_zone,
			'eu.is_active' => 1,
			'td.is_progress' => 1 
		);
		
		$entry_date = date ( 'Y-m-d', strtotime ( '-1 day', strtotime ( $cur_date ) ) );
		$where ['t.entry_date'] = $entry_date;
		
		$this->db->select ( 't.*,td.*', false );
		$this->db->from ( 'project AS pr' );
		$this->db->join ( 'time_sheet AS t', 'pr.project_id = t.project_id', 'INNER' );
		$this->db->join ( 'time_sheet_detail AS td', 't.time_sheet_id=td.time_sheet_id', 'LEFT' );
		$this->db->join ( 'entity_users AS eu', 'eu.user_id = t.user_id' );
		$this->db->where ( $where );
		$query = $this->db->get ();
		
		$result = $query->result_array ();
		
		if($result)
		{
			foreach($result as $row)
			{
				
				// stop previous date timesheet
				$cur_time = '23:59:00';
				$hours = (strtotime ( $cur_time ) - strtotime ( $row ['from_time'] )) / 3600;
				$t_hours = round ( $row ['hours'] + $hours, 2 );
				
				// update time sheet detail
				$this->db->where ( array (
					'time_sheet_detail_id' => $row ['time_sheet_detail_id'],
					'created_by' => $row ['user_id'] 
				) );
				$this->db->update ( 'time_sheet_detail', array (
					'is_progress' => 0,
					'hours' => $hours,
					'to_time' => $cur_time,
					'updated_by' => $row ['user_id'],
					'updated_date' => $cur_time 
				) );
				
				// update time sheet
				$this->db->where ( array (
					'time_sheet_id' => $row ['time_sheet_id'],
					'entity_id' => $row ['entity_id'],
					'created_by' => $row ['user_id'],
					'invoice_id ' => '0',
					'is_progress' => 1 
				) );
				$this->db->where ( '(approved_by=created_by or approval_status="")' );
				$this->db->update ( 'time_sheet', array (
					'is_progress' => 0,
					'hours' => $t_hours,
					'last_updated_by' => $row ['user_id'],
					'last_updated_date' => $cur_time 
				) );
				
				// get fields of from table
				$ts_fields = $this->db->list_fields ( 'time_sheet' );
				
				$ts_data = $tsd_data = array ();
				$skip_fields = array (
					'time_sheet_id',
					'updated_by',
					'updated_date' 
				);
				foreach($ts_fields as $field)
				{
					if(! in_array ( $field, $skip_fields ))
						$ts_data [$field] = $row [$field];
				}
				
				$ts_data ['hours'] = 0;
				$ts_data ['created_date'] = $cur_date;
				$ts_data ['entry_date'] = date ( 'Y-m-d', strtotime ( $cur_date ) );
				
				$this->db->insert ( 'time_sheet', $ts_data );
				$time_sheet_id = $this->db->insert_id ();
				
				// get fields of from table
				$tsd_fields = $this->db->list_fields ( 'time_sheet_detail' );
				unset ( $tsd_fields ['time_sheet_detail_id'] );
				unset ( $tsd_fields ['updated_by'] );
				unset ( $tsd_fields ['updated_date'] );
				
				$tsd_fields = $tsd_data = array ();
				$skip_fields = array (
					'time_sheet_detail_id',
					'updated_by',
					'updated_date' 
				);
				foreach($tsd_fields as $field)
				{
					if(! in_array ( $field, $skip_fields ))
						$tsd_data [$field] = $row [$field];
				}
				$tsd_data ['time_sheet_id'] = $time_sheet_id;
				$tsd_data ['is_progress'] = 1;
				$tsd_data ['from_time'] = '00:00:00';
				$tsd_data ['to_time'] = NULL;
				$tsd_data ['hours'] = NULL;
				$tsd_data ['created_by'] = $row ['user_id'];
				$tsd_data ['created_date'] = $cur_date;
				
				$this->db->insert ( 'time_sheet_detail', $tsd_data );
			}
		}
	}

	public function budget_alert()
	{
		$this->db->select ( 'es.time_zone_code, es.account_owner_id, pr.project_id, pr.invoice_type, pr.entity_id, pr.project_name, pr.project_code, pr.budget_alert_percent, pr.budget_value, pr.budget_type', false );
		$this->db->from ( 'project AS pr' );
		$this->db->join ( 'ot_entity_setting AS es', 'es.entity_id = pr.entity_id' );
		
		$this->db->where ( array (
			'pr.is_active' => 1,
			'pr.budget_alert_percent >' => 0 
		) );
		
		$query = $this->db->get ();
		
		$projects = $query->result_array ();
		
		if(! empty ( $projects ))
		{
			foreach($projects as $key=>$val)
			{
				// if ($val['project_id'] != 20)
				// continue;
				if(method_exists ( $this, 'budget_alert_' . $val ['budget_type'] ))
				{
					call_user_func_array ( array (
						$this,
						'budget_alert_' . $val ['budget_type'] 
					), array (
						$val,
						$this->get_budget_mail_user_list ( $val ) 
					) );
				}
			}
			
			if(! empty ( $this->budget_mail_list ))
			{
				foreach($this->budget_mail_list as $key=>$val)
				{
					$this->send_budget_email ( $val );
				}
				$this->budget_mail_list = array ();
			}
		}
		
		echo '##Finished##';
	}
	
	// Get users list for sending mail to whose.
	private function get_budget_mail_user_list($project, $return_as_filtered = true)
	{
		if(empty ( $project ) || empty ( $project ['project_id'] ))
		{
			return false;
		}
		
		$this->db->select ( 'pu.user_id, eu.email, eu.first_name, eu.last_name, eu.user_role', false );
		$this->db->from ( 'ot_project_users AS pu' );
		$this->db->join ( 'ot_entity_users AS eu', 'eu.user_id = pu.user_id' );
		$this->db->where ( 'pu.entity_id', $project ['entity_id'] );
		$this->db->where ( 'pu.project_id', $project ['project_id'] );
		$this->db->where ( "(`eu`.`user_role` in ('A', 'F', 'P') OR `pu`.`user_id` =" . $project ['account_owner_id'] . ")" );
		$this->db->group_by ( 'pu.user_id' );
		
		$query = $this->db->get ();
		
		$result = $query->result_array ();
		
		if(! $return_as_filtered)
		{
			return $result;
		}
		
		$project_name = $project ['project_code'] . $project ['project_name'];
		$return = array (
			'from' => '',
			'to' => '',
			'cc' => array (),
			'from_name' => '',
			'subject' => 'Budget percent reached for "' . $project_name . '"',
			'message' => 'Your project "' . $project_name . '" has reached the budget ' . $project ['budget_alert_percent'] . ' percent as you mentioned.' 
		);
		
		foreach($result as $key=>$val)
		{
			if($val ['user_id'] == $project ['account_owner_id'])
			{
				$return ['to'] = $val ['email'];
				$return ['from'] = $val ['email'];
				$return ['from_name'] = $val ['first_name'] . $val ['last_name'];
			} else
			{
				// if user is project manager then send mail for Hours based alert only, not for amount based alert.
				if($val ['user_role'] == 'P' && in_array ( $project ['budget_type'], array (
					'AA',
					'AT',
					'AP' 
				) ))
				{
					continue;
				}
				$return ['cc'] [] = $val ['email'];
			}
		}
		
		return $return;
	}
	
	// HA - Total Project Hours
	private function budget_alert_HA($project, $mail_details)
	{
		if(empty ( $project ['budget_value'] ))
		{
			return false;
		}
		
		switch($project ['invoice_type'])
		{
			case 'P': // Person Hourly Rate
				$this->db->select ( 'sum(pu.actual_hours) as total_actual_hours', false );
				$this->db->from ( 'project_users as pu' );
				$this->db->where ( 'pu.entity_id', $project ['entity_id'] );
				$this->db->where ( 'pu.project_id', $project ['project_id'] );
				break;
			case 'T': // Task Hourly Rate
			case 'A': // Project All Hours
			case 'N': // Non-Billable
			default:
				$this->db->select ( 'sum(ptt.actual_hours) as total_actual_hours', false );
				$this->db->from ( 'project_task_types as ptt' );
				$this->db->where ( 'ptt.entity_id', $project ['entity_id'] );
				$this->db->where ( 'ptt.project_id', $project ['project_id'] );
				break;
		}
		
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_hours'] = round ( $result ['total_actual_hours'] );
		
		if(($project ['budget_value'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_hours'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		// echo '<br/>HA<br/>';
		// print_R($result);exit;
		return true;
	}
	
	// HT - Hours based on Task Type
	private function budget_alert_HT($project, $mail_details)
	{
		$this->db->select ( 'sum(ptt.actual_hours) as total_actual_hours, sum(ptt.estimated_hours) as total_estimated_hours', false );
		$this->db->from ( 'project_task_types as ptt' );
		$this->db->where ( 'ptt.entity_id', $project ['entity_id'] );
		$this->db->where ( 'ptt.project_id', $project ['project_id'] );
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_hours'] = round ( $result ['total_actual_hours'] );
		$result ['total_estimated_hours'] = round ( $result ['total_estimated_hours'] );
		
		if(($result ['total_estimated_hours'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_hours'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		// echo '<br/>HT<br/>';
		// print_R($result);exit;
		return true;
	}
	// HP - Hours based on Person
	private function budget_alert_HP($project, $mail_details)
	{
		$this->db->select ( 'sum(pu.actual_hours) as total_actual_hours, sum(pu.estimated_hours) as total_estimated_hours', false );
		$this->db->from ( 'ot_project_users as pu' );
		$this->db->where ( 'pu.entity_id', $project ['entity_id'] );
		$this->db->where ( 'pu.project_id', $project ['project_id'] );
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_hours'] = round ( $result ['total_actual_hours'] );
		$result ['total_estimated_hours'] = round ( $result ['total_estimated_hours'] );
		
		if(($result ['total_estimated_hours'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_hours'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		// echo '<br/>HP<br/>';
		// print_R($result);exit;
		return true;
	}
	
	// AA - Total Project Amount
	private function budget_alert_AA($project, $mail_details)
	{
		if(empty ( $project ['budget_value'] ))
		{
			return false;
		}
		
		switch($project ['invoice_type'])
		{
			case 'P': // Person Hourly Rate
				$this->db->select ( 'sum(pu.actual_hours * pu.hourly_rate) as total_actual_amount', false );
				$this->db->from ( 'project_users as pu' );
				$this->db->where ( 'pu.entity_id', $project ['entity_id'] );
				$this->db->where ( 'pu.project_id', $project ['project_id'] );
				break;
			case 'T': // Task Hourly Rate
			case 'A': // Project All Hours
			case 'N': // Non-Billable
			default:
				$this->db->select ( 'sum(ptt.actual_hours * ptt.hourly_rate) as total_actual_amount', false );
				$this->db->from ( 'project_task_types as ptt' );
				$this->db->where ( 'ptt.entity_id', $project ['entity_id'] );
				$this->db->where ( 'ptt.project_id', $project ['project_id'] );
				break;
		}
		
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_amount'] = round ( $result ['total_actual_amount'] );
		
		if(($project ['budget_value'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_amount'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		// echo '<br/>AA<br/>';
		// print_R($result);exit;
		return true;
	}
	
	// AT - Amount based on Task Type Hours
	private function budget_alert_AT($project, $mail_details)
	{
		$this->db->select ( 'sum(ptt.actual_hours * ptt.hourly_rate) as total_actual_amount, sum(ptt.estimated_hours * ptt.hourly_rate) as total_estimated_amount', false );
		$this->db->from ( 'project_task_types as ptt' );
		$this->db->where ( 'ptt.entity_id', $project ['entity_id'] );
		$this->db->where ( 'ptt.project_id', $project ['project_id'] );
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_amount'] = round ( $result ['total_actual_amount'] );
		$result ['total_estimated_amount'] = round ( $result ['total_estimated_amount'] );
		
		if(($result ['total_estimated_amount'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_amount'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		return true;
	}
	
	// AP - Amount based on Person Hours
	private function budget_alert_AP($project, $mail_details)
	{
		$this->db->select ( 'sum(pu.actual_hours * pu.hourly_rate) as total_actual_amount, sum(pu.estimated_hours * pu.hourly_rate) as total_estimated_amount', false );
		$this->db->from ( 'project_users as pu' );
		$this->db->where ( 'pu.entity_id', $project ['entity_id'] );
		$this->db->where ( 'pu.project_id', $project ['project_id'] );
		$query = $this->db->get ();
		$result = $query->row_array ();
		
		$result ['total_actual_amount'] = round ( $result ['total_actual_amount'] );
		$result ['total_estimated_amount'] = round ( $result ['total_estimated_amount'] );
		
		if(($result ['total_estimated_amount'] * $project ['budget_alert_percent'] / 100) <= $result ['total_actual_amount'])
		{
			$this->budget_mail_list [] = $mail_details;
		}
		
		return true;
	}

	public function get_project_hours($data, $entity_id)
	{
		$sql	= 'sum(if(ts.is_billable=1,ts.hours,0)) as billable_hours, sum(if(ts.is_billable=0,ts.hours,0)) as nonbillable_hours, concat(pr.project_code, pr.project_name) as project_name';
		$sql	.= ',sum(if(ts.invoice_id >0,ts.hours,0)) as invoiced_hours, sum(if(ts.invoice_id<=0 && ts.is_billable=1,ts.hours,0)) as uninvoiced_hours';
		$this->db->select($sql, false);
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr','ts.entity_id=pr.entity_id and ts.project_id = pr.project_id');
		$where	= array('ts.entity_id' => $entity_id);
		if (!empty($data['from_date']) && !empty($data['to_date']))
		{
			$where['ts.entry_date >=']	= $data['from_date'];
			$where['ts.entry_date <=']	= $data['to_date'];
		}
		$this->db->where($where);
// 		$this->db->group_by('pr.project_id');
// 		$this->db->order_by('pr.project_name');
		$query = $this->db->get();

		return $query->result_array();
	}

	public function get_milestones($data, $entity_id)
	{
		$cur_date	= $this->auth->get_timezone_date('Y-m-d', true);
		// today
		$sql = 'SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")="'.$cur_date.'" THEN 1 ELSE 0 END) AS "due_today"';
		// upcoming
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")>"'.$cur_date.'" THEN 1 ELSE 0 END) AS "upcoming"';
		// overdue
		$sql.= ', SUM(case when DATE_FORMAT(pt.finish_date, "%Y-%m-%d")<"'.$cur_date.'" THEN 1 ELSE 0 END) AS "overdue"';
		$this->db->select($sql, false);
		$this->db->from('project_task AS pt');
		$where = array('pt.entity_id'=>$entity_id, 'pt.is_closed !=' => 1, 'pt.is_milestone' => 1);
		if (!empty($data['project_id']))
			$where['pt.project_id'] = $data['project_id'];
		$this->db->where($where);
		$query = $this->db->get();
	
		return $query->result_array();
	}

	private function send_budget_email($data)
	{
		$this->load->library ( 'email', array (
			'mailtype' => 'html' 
		) );
		
		$this->email->from ( $this->config->item ( 'smtp_user' ), $this->config->item ( 'domain_name' ) );
		$this->email->to ( $data ['to'] );
		$this->email->cc ( $data ['cc'] );
		$this->email->subject ( $data ['subject'] );
		$this->email->message ( nl2br ( $data ['message'] ) );
		
		if(! $this->email->send ())
		{
			echo 'Failled<br/>';
			return false;
		}
		
		return true;
	}

	public function archive_data()
	{
		$entity = $this->session->userdata ( 'entity' );
		
		if(! $entity || $entity->plan == 'T')
		{
			return true;
		}
		$p_limit = $c_limit = $u_limit = $entity->max_users;
		
		$this->db->select ( 'project_id, client_id, created_by' )->from ( 'project' );
		$this->db->where ( array (
			'entity_id' => $entity->entity_id,
			'is_active' => 1 
		) );
		$this->db->order_by ( 'project_id', 'desc' );
		$this->db->limit ( $p_limit );
		
		$query = $this->db->get ();
		$results = $query->result_array ();
		
		if($results)
		{
			
			$query = $this->db->select ( 'account_owner_id' )->from ( 'entity_setting' )->where ( array (
				'entity_id' => $entity->entity_id 
			) )->get ();
			$row = $query->row ();
			$user_ids [] = $row->account_owner_id;
			
			foreach($results as $row)
			{
				$project_ids [] = $row ['project_id'];
				$client_ids [] = $row ['client_id'];
				$user_ids [] = $row ['created_by'];
			}
			
			$this->db->where ( array (
				'entity_id' => $entity->entity_id 
			) );
			$this->db->where_not_in ( 'project_id', $project_ids );
			$this->db->update ( 'project', array (
				'is_active' => 0 
			) );
			
			$client_ids = array_unique ( $client_ids );
			$tmp_count = $c_limit - count ( $client_ids );
			
			if($tmp_count)
			{
				$this->db->select ( 'client_id' )->from ( 'client' );
				$this->db->where ( array (
					'entity_id' => $entity->entity_id 
				) );
				$this->db->where_not_in ( 'client_id', $client_ids );
				$this->db->order_by ( 'client_id', 'desc' );
				$this->db->limit ( $tmp_count );
				
				$query = $this->db->get ();
				$results = $query->result_array ();
				
				if($results)
				{
					foreach($results as $row)
					{
						$client_ids [] = $row ['client_id'];
					}
				}
			}
			
			$this->db->where ( array (
				'entity_id' => $entity->entity_id 
			) );
			$this->db->where_not_in ( 'client_id', $client_ids );
			$this->db->update ( 'client', array (
				'is_active' => 0 
			) );
			
			$user_ids = array_unique ( $user_ids );
			$tmp_count = $u_limit - count ( $user_ids );
			
			if($tmp_count)
			{
				$user_roles = array ('A','F','P','M');
				foreach($user_roles as $role)
				{
					$this->db->select ( 'user_id' );
					$this->db->where ( array (
						'entity_id' => $entity->entity_id,
						'user_role' => $role,
						'is_active' => 1 
					) );
					$this->db->where_not_in ( 'user_id', $user_ids );
					$this->db->from ( 'entity_users' );
					$this->db->order_by ( 'user_id', 'desc' );
					$this->db->limit ( $tmp_count );
					$query = $this->db->get ();
					$results = $query->result_array ();
					
					if($results)
					{
						foreach($results as $row)
						{
							$user_ids [] = $row ['user_id'];
							$tmp_count --;
						}
					}
					if(! $tmp_count)
						break;
				}
			} else {
				$user_ids = array_slice ( $user_ids, 0, $u_limit );
			}

			$this->db->where ( array (
				'entity_id' => $entity->entity_id 
			) );
			$this->db->where_not_in ( 'user_id', $user_ids );
			$this->db->update ( 'entity_users', array (
				'is_active' => 0 
			) );
			
			$this->db->where ( 'entity_id', $entity->entity_id );
			$this->db->where_not_in ( 'user_id', $user_ids );
			$this->db->delete ( 'users_auth_tokens' );
			
			$this->db->where ( array (
				'entity_id' => $entity->entity_id 
			) );
			$this->db->update ( 'entity_accounts', array (
				'max_users' => $u_limit 
			) );
		}
		
		return true;
	}

	public function upgrade()
	{
		if(defined('APP_EXP') && function_exists('upgrade'))
		{
			return upgrade();
		}
		return false;
	}

	public function license_reminders()
	{
		if(function_exists ( 'license_reminders' ))
		{
			return license_reminders ();
		}
	}

	public function mail($data)
	{
		$this->load->library ( 'email' );
		$email_config = array (
			'mailtype' => 'html',
			'charset' => 'utf-8' 
		);
		$this->email->initialize ( $email_config );
		$email = $this->email;
		$email->clear ();
		$email->to ( $data ['to_email'] );
		$email->from ( $data ['from_email'], $data ['from_name'] );
		$email->subject ( $data ['sub'] );
		$email->message ( nl2br ( $data ['msg'] ) );
		
		if(! $email->send ())
		{
			$this->error = $email->print_debugger ();
			return false;
		}
		
		return true;
	}

	public function week_summary_mail() {

//		$config ['mailtype'] = 'html';
		$this->load->library ( 'email');
		$this->load->library('parser');

		$file	= FCPATH . 'uploads/mail_log/'.date('D').'_weekly_summary_mail.log';
		file_put_contents($file, PHP_EOL.$this->auth->get_timezone_date('', 'UTC'). PHP_EOL, FILE_APPEND);

		$entities = $this->get_entities ();
		$date_formats = $this->config->item('date_formats');
		foreach ($entities as $key => $entity) {

			$date_format = $date_formats[$entity['date_format']];
			$cur_date	= $this->auth->get_timezone_date('', $entity['time_zone_code']);
			$local_timestamp = strtotime($cur_date);
			$tmp_date		= date('Y-m-d 00:14:00', $local_timestamp);
			$diff = strtotime($tmp_date)-$local_timestamp;

			// get day
			$day = strtoupper(substr(date('D',$local_timestamp),0,2));

			if ($entity['start_week_on']==$day && $diff>0) {
			// if ($entity['entity_id'] == 4) {
				$tmp = explode(',', $entity['domain_url']);
				$domain_url = $tmp[0];

				$entity_id = $entity['entity_id'];
				$from_date	= date('Y-m-d', $local_timestamp - (24*60*60*7));
				$to_date	= date('Y-m-d', $local_timestamp - (24*60*60));

				// get days
				$week = array();				
				for ($i=0;$i<7;$i++){
					$n = 7 - $i;
					$week['days']['day_'.$i] = date('D', $local_timestamp - (24*60*60*$n));
					$week['hours']['day_'.$i.'_value'] = '';
				}

				// get entity users
				$this->db->select('eu.first_name, eu.last_name, eu.email, eu.user_id, eu.user_role');
				$this->db->from('entity_users AS eu');
				$this->db->join('user_mails AS um', 'um.user_id=eu.user_id', 'left');
				$this->db->where(array('eu.entity_id' => $entity['entity_id'], 'eu.is_active' => 1, 'um.mail_type'=>'WS', 'um.is_subscribed'=>1));

				$query = $this->db->get ();
				$ent_users = $query->result_array ();

				if (!$ent_users) continue; // no active users continue

				// get data based on previous week
				$where = array('entity_id' => $entity_id);
				$where['entry_date >= ']	= date('Y-m-d', $local_timestamp - (24*60*60*7));
				$where['entry_date <= ']	= date('Y-m-d', $local_timestamp - (24*60*60));


				// get worked hours based on date
				$this->db->select('sum(hours) as hours, user_id, DATE_FORMAT( `entry_date` , "%a" ) as day, sum(case when is_billable=1 then hours else 0 end) as billable,  sum(case when is_billable=0 then hours else 0 end) as non_billable', false);
				$this->db->from('time_sheet');
				$this->db->where($where);
				$this->db->group_by ( 'entry_date, user_id' );
				$query = $this->db->get ();

				$result = $query->result_array ();
				
				$ts_details = array();
				$day_keys = array_flip($week['days']);
				if ($result) {

					// prepare user data
					foreach ($result as $val) {
						if (empty($ts_details[$val['user_id']])) {
								$ts_details[$val['user_id']]=$week['hours'];
						}
						$ts_details[$val['user_id']][$day_keys[$val['day']].'_value'] = number_to_time($val['hours']);
						if (!isset($ts_details[$val['user_id']]['billable'])) {
							$ts_details[$val['user_id']]['billable'] = 0;
							$ts_details[$val['user_id']]['non_billable'] = 0;
						}
						$ts_details[$val['user_id']]['billable'] += $val['billable'];
						$ts_details[$val['user_id']]['non_billable'] += $val['non_billable'];
					}
				}

				// get hours details based on project
				$this->db->select('project_id, sum(case when is_billable=1 then hours else 0 end) as billable,  sum(case when is_billable=0 then hours else 0 end) as non_billable, sum(if(invoice_id >0,hours,0)) as invoiced, sum(if(invoice_id<=0 && is_billable=1,hours,0)) as uninvoiced', false);
				$this->db->from('time_sheet');
				$this->db->where($where);
				$this->db->group_by ( 'project_id' );
				$query = $this->db->get ();

				$project_hours = array_key_index($query->result_array (), 'project_id');

				// get user project map where user not a member
				$this->db->select('p.project_id, pu.user_id');
				$this->db->from('project AS p');
				$this->db->join('project_users AS pu', 'p.project_id = pu.project_id');
				$this->db->where(array('p.entity_id' => $entity_id, 'p.is_active' => 1, 'pu.user_role !=' => 'M'));
				$query = $this->db->get ();

				$result = $query->result_array ();
				$pro_user_map = array();

				if ($result) {
					foreach ($result as $phval) {
						// $user_id = $phval['user_id'];
//						if (isset($projects[$phval['user_id']])) {
							$pro_user_map[$phval['user_id']][] = $phval['project_id'];
//						}
					}
				}

				// prepare data for week before last week ****************************
				// timesheet hours
				$where 			= array('entity_id' => $entity_id);
				$lw_from_date	= date('Y-m-d', $local_timestamp - (24*60*60*14));
				$lw_to_date		= date('Y-m-d', $local_timestamp - (24*60*60*8));
				$where['entry_date >= ']	= $lw_from_date;
				$where['entry_date <= ']	= $lw_to_date;

				$this->db->select('user_id, sum(case when is_billable=1 then hours else 0 end) as lw_billable,  sum(case when is_billable=0 then hours else 0 end) as lw_non_billable', false);
				$this->db->from('time_sheet');
				$this->db->where($where);
				$this->db->group_by ( 'user_id' );
				$query = $this->db->get ();

				$lw_result = array_key_index($query->result_array (), 'user_id');


				// billable and invoice relate data based on projects
				$this->db->select('project_id, sum(case when is_billable=1 then hours else 0 end) as billable,  sum(case when is_billable=0 then hours else 0 end) as non_billable, sum(if(invoice_id >0,hours,0)) as invoiced, sum(if(invoice_id<=0 && is_billable=1,hours,0)) as uninvoiced', false);
				$this->db->from('time_sheet');
				$this->db->where($where);
				$this->db->group_by ( 'project_id' );
				$query = $this->db->get ();

				$lw_project_hours = array_key_index($query->result_array (), 'project_id');

				$ts_default_values = array(
								'day_0_value' => '-',
								'day_1_value' => '-',
								'day_2_value' => '-',
								'day_3_value' => '-',
								'day_4_value' => '-',
								'day_5_value' => '-',
								'day_6_value' => '-',
								'billable' => 0,
								'non_billable' => 0);
//				foreach ($ts_details as $user_id => $val) {
				foreach ($ent_users as $val) {
					$user_id = $val['user_id'];
					$val = array_merge($val, $week['days']);
					$val['from_date'] 	= date($date_format, $local_timestamp - (24*60*60*7));
					$val['to_date'] 	= date($date_format, $local_timestamp - (24*60*60));

					$val['domain_url'] 	= 'http://'.$domain_url;
					$val['report_url']	= $val['domain_url'].'index.php/report/time?US='.$user_id.'&dt_ty=CU&fd='.date('Y-m-d', $local_timestamp - (24*60*60*7)).'&td='.date('Y-m-d', $local_timestamp - (24*60*60)).'&gb=CL&sb=DA&rc=T&rv=S';
					$val['unsub_url'] 	= 'http://'.$domain_url.'/index.php/profile';

					if (isset($ts_details[$user_id])) {
						$val = array_merge($val, $ts_details[$user_id]);
					} else {
						$val = array_merge($val, $ts_default_values);
					}

					if (isset($pro_user_map[$user_id]))
						$val['projects'] = $pro_user_map[$user_id];

					$lw_row = array('lw_billable' => 0 ,'lw_non_billable' => 0); 
					if (isset($lw_result[$user_id])) {
						$lw_row = 	$lw_result[$user_id];
					}
					$val = array_merge($val, $lw_row);

					// hours format
					$val['tot_hrs'] 		= number_to_time($val['billable'] + $val['non_billable']);
					$val['billable'] 		= number_to_time($val['billable']);
					$val['non_billable']	= number_to_time($val['non_billable']);

					$val['lw_tot_hrs'] 		= number_to_time($val['lw_billable'] + $val['lw_non_billable']);
					$val['lw_billable'] 		= number_to_time($val['lw_billable']);
					$val['lw_non_billable']	= number_to_time($val['lw_non_billable']);
					// billable and invoice details if user not a member
					$val['team'] = array();
					$val['invoice_data'] = array();
					$val['payment_data'] = array();
					if (!is_member($val['user_role'])) {
						
						$team_billable = $team_non_billable = $team_total = $team_invoiced= $team_uninvoiced = 0;
						$data		= array(
								'team_billable' => $team_billable, 'team_non_billable' => $team_non_billable, 'team_total' => $team_total, 
								'lw_team_billable' => $team_billable, 'lw_team_non_billable' => $team_non_billable, 'lw_team_total' => $team_total
						);
						$data_invoiced = array('team_invoiced'	=> $team_invoiced, 'team_uninvoiced'	=> $team_uninvoiced,
								'lw_team_invoiced'	=> $team_invoiced, 'lw_team_uninvoiced'	=> $lw_team_uninvoiced);

						if (is_admin($val['user_role'])) {
								$val['projects'] = array_merge(array_keys($lw_project_hours), array_keys($project_hours));
								$val['projects'] = array_unique($val['projects']);
						}
						$invoice_data = (!is_pm($val['user_role']))?true:false;
						if (!empty($val['projects'])) {
							foreach($val['projects'] as $pro_id) {
								// for current week
								if (!empty($project_hours[$pro_id])) {
									$phrs	= $project_hours[$pro_id];
									$data['team_billable'] += $phrs['billable'];
									$data['team_non_billable'] += $phrs['non_billable'];
									if ($invoice_data) {
										$data_invoiced['team_invoiced'] += $phrs['invoiced'];
										$data_invoiced['team_uninvoiced'] += $phrs['uninvoiced'];
									}
									$data['team_total']		= $data['team_billable']+$data['team_non_billable'];
								}
								// for last week
								if (!empty($lw_project_hours[$pro_id])) {
									$phrs	= $lw_project_hours[$pro_id];
									$data['lw_team_billable'] += $phrs['billable'];
									$data['lw_team_non_billable'] += $phrs['non_billable'];
									if ($invoice_data) {
										$data_invoiced['lw_team_invoiced'] += $phrs['invoiced'];
										$data_invoiced['lw_team_uninvoiced'] += $phrs['uninvoiced'];
									}
									$data['lw_team_total']			= $data['lw_team_billable']+$data['lw_team_non_billable'];
								}
							}
							$data['team_billable']			= round($data['team_billable']);
							$data['team_non_billable']		= round($data['team_non_billable']);
							$data['team_total']				= $data['team_billable'] + $data['team_non_billable'];
							$data['lw_team_billable']		= round($data['lw_team_billable']);
							$data['lw_team_non_billable']	= round($data['lw_team_non_billable']);
							$data['lw_team_total']			= $data['lw_team_billable'] + $data['lw_team_non_billable'];

							if ($invoice_data) {
								$data_invoiced['team_invoiced']			= round($data_invoiced['team_invoiced']);
								$data_invoiced['team_uninvoiced']		= round($data_invoiced['team_uninvoiced']);
								$data_invoiced['lw_team_invoiced']		= round($data_invoiced['lw_team_invoiced']);
								$data_invoiced['lw_team_uninvoiced']	= round($data_invoiced['lw_team_uninvoiced']);
							}

							$val['team'][0] = $data;

							if (is_admin($val['user_role'])) {
								// expenses
								$this->db->select('sum(exp.amount) as exp_amount', false);
								$this->db->from('project_expense as exp');
								$where 		= array('exp.entity_id' => $entity_id);

								$where['exp.expense_date >=']=$from_date;
								$where['exp.expense_date <=']=$to_date;

								$this->db->where($where);
								$query = $this->db->get();
	
								$exp_result =  $query->row_array();

								$this->db->select('sum(exp.amount) as lw_exp_amount', false);
								$this->db->from('project_expense as exp');
								$where 		= array('exp.entity_id' => $entity_id);

								$where['exp.expense_date >=']=$lw_from_date;
								$where['exp.expense_date <=']=$lw_to_date;

								$this->db->where($where);
								$query = $this->db->get();
	
								$lw_exp_result =  $query->row_array();

								$this->db->select('sum(ivp.amount) as inc_amount', false);
								$this->db->from('invoice as iv');
								$this->db->join('invoice_payment as ivp', 'iv.entity_id=ivp.entity_id and iv.invoice_id = ivp.invoice_id');
								$where 		= array('iv.entity_id' => $entity_id, 'iv.is_archive' => 0, 'iv.currency_code' => $entity['currency_code']);

								$where['ivp.payment_date >=']=$from_date;
								$where['ivp.payment_date <=']=$to_date;

								$this->db->where($where);
								$query = $this->db->get();
								//echo $this->db->last_query();
								$inv_result = $query->row_array();

								$this->db->select('sum(ivp.amount) as lw_inc_amount', false);
								$this->db->from('invoice as iv');
								$this->db->join('invoice_payment as ivp', 'iv.entity_id=ivp.entity_id and iv.invoice_id = ivp.invoice_id');
								$where 		= array('iv.entity_id' => $entity_id, 'iv.is_archive' => 0, 'iv.currency_code' => $entity['currency_code']);

								$where['ivp.payment_date >=']=$lw_from_date;
								$where['ivp.payment_date <=']=$lw_to_date;
								
								$this->db->where($where);
								$query = $this->db->get();
								// echo $this->db->last_query();
								$lw_inv_result = $query->row_array();

								$exp_result['exp_amount'] 		= round($exp_result['exp_amount']?$exp_result['exp_amount']:0);
								$lw_exp_result['lw_exp_amount'] = round($lw_exp_result['lw_exp_amount']?$lw_exp_result['lw_exp_amount']:0);
								$inv_result['inc_amount']		= round($inv_result['inc_amount']?$inv_result['inc_amount']:0);
								$lw_inv_result['lw_inc_amount'] = round($lw_inv_result['lw_inc_amount']?$lw_inv_result['lw_inc_amount']:0);

								$val['payment_data'][0] = array_merge($exp_result, $inv_result, $lw_exp_result, $lw_inv_result );
								$val['payment_data'][0]['currency'] = get_currency($entity['currency_code']);
							}
							if ($invoice_data) {
								$val['invoice_data'][0] = $data_invoiced;
							}
						}
					}


					$mail_template = $this->parser->parse('mail_templates/week_logged_time', $val, TRUE);
//echo $val ['email']."--->".$val['user_role']."\n".$mail_template."\n";
					$email_config = array(
						'mailtype'	=> 'html',
						'charset'	=> 'utf-8'
					);
					$this->email->initialize($email_config);
					$this->email->from ( $this->config->item ( 'smtp_user' ), $this->config->item ( 'domain_name' ) );
					$this->email->to ( $val ['email'] );
					$this->email->subject ('Output Time - Weekly Report');
					$this->email->message ( $mail_template );
					$log = '';
					if (!$this->email->send ()) {
						$log .="ERR!"; 
						echo 'Mail send error!';
					}
					$file	= FCPATH . 'uploads/mail_log/'.date('D').'_weekly_summary_mail.log';

					file_put_contents($file, $val['email'] . PHP_EOL . print_R($val, true) . PHP_EOL . $log.'.-----------------------------' . PHP_EOL, FILE_APPEND);
				}
				// }
			}
		}
	}
}

/* End of file mod.cron.php */
