<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Projects_member extends CI_Model
{
	private $_entity_id	= 0;

	private $_user_id	= 0;

	function __construct()
	{
		parent::__construct();
		$this->load->library(OTBASE_PATH.'OT_App');
     	$this->load->library(OTBASE_PATH.'OT_User');

		$this->_entity_id	= $this->ot_app->get('entity_id');
		$this->_user_id		= $this->ot_user->get('user_id');
	}

	// Magic function return false
	public function __call($name, $arguments)
    {
       return array();
    }

// 	return projects list query
	public function projects_list_query($select, $options = array())
	{
		$restricted_fields = array('pr.budget_value', 'pr.actual_value', 'pr.budget_type');

		$split = explode(',', $select);

		foreach($split as $key => $val)
		{
			$val = trim($val);
			if ($val && in_array($val,$restricted_fields))
			{
				$value = explode('.',$val);
				$val = (isset($value[1]))?$value[1]:$val;
				$split[$key] = '-1 AS '.$val;
			}
		}
		$select = implode(',', $split);
		$where	= array();

		$this->db->select($select.", pru.user_role", FALSE);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id = pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$this->db->join('client as cl', 'pr.entity_id=cl.entity_id and pr.client_id = cl.client_id', 'INNER');

		if (!empty($options['filters']))
		{
			foreach($options['filters'] as $key=>$val)
			{
				if (is_array($val))
					$this->db->where_in($key,$val);
				else
					$where[$key] = $val;
			}
		}

		$where['pr.entity_id']	= $this->_entity_id;
		if (empty($where['pru.user_id']))
		{
			$where['pru.user_id']	= $this->_user_id;
		}

		$this->db->where($where);

		if (empty($options['union_query']))
		{
			$order_by 			= !empty($options['order_by']) ? $options['order_by'] : 'pr.project_name';
			$order_by_direction = !empty($options['order_by_direction']) ? $options['order_by_direction'] : 'asc';

			$this->db->order_by($order_by, $order_by_direction);
		}

		$from = !empty($options['from'])?$options['from']:0;
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}

		return $this->db->get();
	}

	// return projects in as array of standard array indexes
	public function get_projects($select = '', $options = array())
	{
		$select = ($select)?$select:'pr.project_id, cl.client_id, concat(pr.project_code, pr.project_name) AS project_name, pr.project_code,  pr.members_count, pr.created_date, pr.is_active, pr.bg_color, pr.created_by';
		$query = $this->projects_list_query($select, $options);

		return $query->result_array();
	}

	public function get_project_count($active = 0)
	{
		$this->db->select('SUM(pr.is_active=1) AS active_count,SUM(pr.is_active=0) AS archive_count', false);
		$this->db->from('project pr');
		$this->db->join('project_users AS pru', 'pr.entity_id=pru.entity_id AND pr.project_id = pru.project_id');

		$this->db->where(array(
			'pr.entity_id'	=> $this->_entity_id,
			'pru.user_id'	=> $this->_user_id
		));

		$query = $this->db->get();

		$result = $query->row_array();
		return $result['archive_count'];
	}

	public function get_new_count($pro_ids)
	{
		$this->db->select('project_id, new_comments');
		$this->db->from('project_users');

		$this->db->where(array(
			'entity_id'	=> $this->_entity_id,
			'user_id'	=> $this->_user_id
		));

		$this->db->where_in('project_id', $pro_ids);

		$query	= $this->db->get();
		$result	= $query->result_array();

		return $result;
	}
}
