<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/report/mod.report_pmf.php');

class Report_admin extends Report_pmf
{
	function __construct()
	{
		parent::__construct();
	}
	
	public function get_items($data, $select = array())
	{
		if($data['report_code']!='IA' && $data['report_code']!='IU' ) 
		{
			$diff = abs(strtotime($data['filters']['to_date']) - strtotime($data['filters']['from_date']));
			$diff_days = floor($diff/ (60*60*24));
			if($data['report_code']!='IS') 	{				
				/*if (isset($select[REP_PERIOD]) && $diff_days >=31)
				{
					$select[REP_PERIOD][0] = str_replace('%Y-%m-%d', '%b', $select[REP_PERIOD][0]);
				}
				if (isset($select[REP_EXPENSE_PERIOD]) && $diff_days >=31)
				{
					$select[REP_EXPENSE_PERIOD][0] = str_replace('%Y-%m-%d', '%b', $select[REP_EXPENSE_PERIOD][0]);
				}*/
				if($data['report_code']==REPORT_TASK_DETAIL && !empty($select[REP_TASK_TYPE])) {
						$this->db->select('pt.task_type_id');
				}
				if($data['report_code']==REPORT_TASK_SUMMARY) {
					foreach ($select as $key => $val) {
						if($key!=REP_HOURS) {
							$this->db->select($val[0], false);
						}
					}
				} else {
					foreach ($select as $key => $val) {
						$this->db->select($val[0], false);
					}
				}
			} else {
				if (isset($select[REP_INVOICE_PERIOD]) && $diff_days >=31)
				{
					$select[REP_INVOICE_PERIOD][0] = str_replace('%Y-%m-%d', '%b', $select[REP_INVOICE_PERIOD][0]);
				}
			}
			

			$this->set_items_where($data, $select);
			$group_by		= !empty($data['group_by']) ? $data['group_by']:REP_PERIOD;
			$query 			= $this->db->get();
			// echo $this->db->last_query();
			$result['items'] = $query->result_array();
		}

		//if ($result['items']) {
			switch($data['report_code']) {
				case REPORT_TIME_DETAIL:
					$tmp = $result['items'];
					$time_sheet_ids = $result['items'] = array();
					
					foreach ($tmp as $row)
					{
						if (!empty($select[REP_START_AND_END_TIME]))
							$time_sheet_ids[] = $row[REP_START_AND_END_TIME];
							
						$key = $row[$group_by];
						$result['details'][$key][] = $row;
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else if ($group_by==$rkey) {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
					if ($time_sheet_ids) {
						$this->load->model('timesheets');
						$time_details = $this->timesheets->get_details($time_sheet_ids, 'td.time_sheet_id,td.from_time, td.to_time');
						
						if ($time_details) {
							foreach ($time_details as $row)
							{
								$result['time_details'][$row['time_sheet_id']][] = array(date('H:i',strtotime($row['from_time'])),date('H:i',strtotime($row['to_time']))); 
							}
						}
					}
					if(!empty($result['items']))
						$result['chart'] = $this->get_totals($data);
				break;
				case REPORT_TIME_DETAIL:
				case REPORT_TIME_SUMMARY:
					$tmp = $result['items'];
					$result['items'] = array();
					
					$g_map = $this->report_lib->get_detail_group_by($data);
					if (isset($g_map[$group_by])) {
						$group_key = 'gpby';
					}
					foreach ($tmp as $row)
					{
						$key = (isset($group_key))?$row[$group_key]:$row[$group_by];
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
					if(!empty($result['items'])) {
						$this->db->select('sum(ts.hours * ts.is_billable ) AS billable, sum(ts.hours * ! ts.is_billable ) AS non_billable');
						$result['chart'] = $this->get_totals($data);
					}
				break;	
				case REPORT_TASK_SUMMARY:
					if (!empty($select[REP_HOURS]) && !empty($result['items'])) {
						$items = array();
						foreach ($result['items'] as $item) {
							$items[$item['detail_filter']] = $item;
						}
						 $this->db->select($select[REP_HOURS][0].', project_task_id', false);
						$this->db->from('time_sheet AS ts');
						$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'project_task_id >'=> 0 , 'entry_date >=' => $data['filters']['from_date'], 'entry_date <=' => $data['filters']['to_date']));
						if ($data['filters']['US'][0]!='all') {
							$this->db->where_in('ts.user_id', $data['filters']['US']);
						}
						$query = $this->db->group_by('project_task_id')->get();
						$ts_totals = $query->result_array();

						if ($ts_totals) {
							foreach ($ts_totals as $row) {
								if (!empty($items[$row['project_task_id']])) {
										$items[$row['project_task_id']][REP_HOURS] = $row[REP_HOURS];
								}
							}
							$result['items'] = array_values($items);
						}
					}
				case REPORT_TASK_DETAIL:
					if ($data['report_code']==REPORT_TASK_DETAIL && $result['items']) {
						$this->load->model('entity');
						$tmp_task_types = $this->entity->get_task_types('task_type_id, name');
						$task_types = array();

						foreach ($tmp_task_types as $tt) {
							$task_types[$tt['task_type_id']] = $tt['name'];
						}

						$tmp_items = $result['items'];
						$result['items'] = array();
						foreach ($tmp_items as $row) {
							$key =$row['detail_filter'];
							if (!isset($result['items'][$key])) {
								$result['items'][$key] = array();
							}
							$result['details'][$key][] = $row;
							foreach ($row as $rkey => $val)
							{
								if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
									$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
								} 
								switch ($rkey) {
									case REP_STATUS_BGCOLOR:
									case REP_STATUS_TEXT_COLOR:
									case REP_PROJECT_TASK:
										$result['items'][$key][$rkey] = $val;
									break;
									case 'task_type_id':
										$result['items'][$key][REP_TASK_TYPE] = isset($task_types[$val])?$task_types[$val]:'';
									break;
									case REP_PERIOD:
										$result['items'][$key][$rkey] = $row[REP_STATUS];
									break;
								}
							}
						}
					}
					$result['chart'] = $this->get_totals($data);
				break; 	
				case REPORT_INVOICE_SUMMARY:
					$items = $result['items'];
					$data['payment'] = true;
					$this->get_invoice_report_query($data, $select);

					$query 	 = $this->db->get();
					$payment = $query->result_array();

					if(!empty($payment) && isset($payment[0][$group_by]))
					{
						foreach($payment as $key=>$value)
						{
							foreach($items as $ikey=>$ivalue)
							{
								if($payment[$key][$group_by] == $items[$ikey][$group_by])
								{
									$result['items'][$ikey]	= array_merge($payment[$key], $items[$ikey]);
								}
							}
						}
					}
					$total_columns = array(REP_INVOICE_AMOUNT, REP_INVOICE_COUNT, REP_PAYMENT_AMOUNT, REP_PAYMENT_COUNT, REP_DEP_INV_COUNT, REP_DEP_INV_AMOUNT, REP_PAY_COUNT, REP_PAY_AMOUNT);
					$heading = array(REP_INVOICE_AMOUNT, REP_PAYMENT_AMOUNT, REP_DEP_INV_AMOUNT, REP_PAY_AMOUNT);
					$result = $this->total_with_diff_currency($result, $total_columns, $heading);
					$result['chart'] = $this->get_totals($data);
				break; 		
				case REPORT_INVOICE_DETAIL:
					$heading = array(REP_AMOUNT, REP_OUTSTANDING, REP_DISCOUNT_AMOUNT, REP_TAX1_AMOUNT, REP_TAX2_AMOUNT, REP_TAX3_AMOUNT);
					$result = $this->total_with_diff_currency($result, array(), $heading);
					if ($result['items'] && !empty($data['export_type'])) {
						$inv_status =  $this->config->config['invoice_status'];
						foreach ($result['items'] as $key=>$inv) {
							if (!isset($result['items'][$key][REP_INVOICE_STATUS])) {
								break;
							}
							$result['items'][$key][REP_INVOICE_STATUS] = $inv_status[$result['items'][$key][REP_INVOICE_STATUS]];
						}
					}
				break;	
				case REPORT_INVOICE_AGING:	
					$sql_query = $this->get_invoice_aging_report_query($data, $select);
					//$sql_query = $this->db->query($query);
					$result['items'] = $sql_query->result_array();	
					
					$total_columns = array('CT','T1','T2','T3','TL');
					$result = $this->total_with_diff_currency($result, $total_columns);
				break; 	
				case REPORT_INVOICE_OUTSTANDING:
					$total_columns = array(REP_AMOUNT,REP_OUTSTANDING);
					$result = $this->total_with_diff_currency($result, $total_columns);
					if(isset($data['params']['client_id'])) {
					$client = $this->client->get_client($data['params']['client_id'],'client_name');
					$result['filter_label'][] = 'Client : ' . $client['client_name'];
					}
					if(!empty($data['params']['aging_link'])) {
						$column = substr($data['params']['aging_link'],1,1);
						
						if($column>0 && $column<3)
							$result['filter_label'][]	   = 'Age: ' . ($column-1)*$data['interval'] . ' - ' .  ($column)*$data['interval'] . ' Days';
						if($column==3)
							$result['filter_label'][]	   = 'Above ' . ($column-1)*$data['interval'] . ' Days';
						//if($data['aging_link']=='CT') $result['filter_label'][] = 'Current';
						//if($data['aging_link']=='TL') $result['filter_label'][] = 'Total';	
					}
				break;	
				case REPORT_INVOICE_UNINVOICED;
					$query = $this->get_invoice_uninvoiced_query($data, $select);
					$sql_query = $this->db->query($query);
					$result['items'] = $sql_query->result_array();
					if(!empty($result['items'])) 
					{
						foreach($result['items'] as $key=>$value) 
						{
							switch($value['budget_type']) {
								case 'HA':
								case 'HT':
									$hours_task[]	= $value[REP_PROJECT_ID];
								break;
								case 'HP':
									$hours_person[] = $value[REP_PROJECT_ID];
								break;
								default:	
									$amount_based[] = $value[REP_PROJECT_ID];
								break;
							}				
						}  
						if(!empty($hours_task)) 
						{
							$select = 't.project_id, sum(ty.hourly_rate * t.hours) as actual_value';
							$this->db->select($select, false);
							$this->db->from('project_task_types AS ty');
							$this->db->join('time_sheet As t', 'ty.project_id=t.project_id AND ty.task_type_id = t.task_type_id', 'left');
							$this->db->where_in('t.project_id', $hours_task);
							$query 	= $this->db->get();
							$actual = $query->result_array();
						}
						if(!empty($hours_person)) {
							$select = 't.project_id, sum(tu.hourly_rate * t.hours) as actual_value';
							$this->db->select($select, false);
							$this->db->from('project_users AS tu');
							$this->db->join('time_sheet As t', 'tu.project_id = t.project_id AND t.user_id = tu.user_id', 'left');
							$this->db->where_in('t.project_id', $hours_person);
							$query 	= $this->db->get();
							$actual = $query->result_array();
						}
						if(!empty($amount_based)) {
							$select = 't.project_id, t.actual_value as actual_value';
							$this->db->select($select, false);
							$this->db->from('project As t');
							$this->db->where_in('t.project_id', $amount_based);
							$query 	= $this->db->get();
							$actual = $query->result_array();
						}
						
						if(!empty($actual)) 
						{
							foreach($actual as $k=>$v) 
								$hours[$v['project_id']] = $v['actual_value'];
	
							foreach($result['items'] as $key=>$value) 
								if(!empty($hours[$value[REP_PROJECT_ID]]))
									$result['items'][$key][REP_UNINVOICED_AMOUNT_APPROVED_TOTAL]+=$hours[$value[REP_PROJECT_ID]];
						}
					}
				break;
				case REPORT_INVOICE_UNINVOICED_HOURS_DETAIL;
				case REPORT_INVOICE_UNINVOICED_EXPENSE_DETAIL:
				break;	
				case REPORT_BUDGET:
				//	$result['chart'] = $this->get_totals($data);
				break;	
				case REPORT_BUDGET_DETAIL:
					if(!empty($data['params'])) {
						$client 		= $this->client->get_client($data['params']['client_id']);
						$project_name	= $this->project->get_project_name($data['params']['project_id']);
						
						$result['filter_label'][] = 'Client : ' . $client['client_code'] . $client['client_name'];
						$result['filter_label'][] = 'Project : ' . $project_name;
					}  
				break; 
				case REPORT_EXPENSE_SUMMARY:
					if(!empty($result['items'])) {
						$items = $result['items'];	
						$total = 0;
						foreach($items as $key=>$value) {
							if(!isset($items[$key][REP_AMOUNT_TOTAL]))
								break;
							$total+=$items[$key][REP_AMOUNT_TOTAL]; 	
							$result['total'][REP_AMOUNT_TOTAL] = $total;							
						}
						if(isset($result['total'][REP_AMOUNT_TOTAL]))
							$result['total'][REP_AMOUNT_TOTAL] = CURRENCY . $result['total'][REP_AMOUNT_TOTAL];

						//$result['chart'] = $this->get_totals($data);
					}	
				break;	
				case REPORT_EXPENSE_DETAIL:
					$tmp = $result['items'];
					$result['items'] = array();
					foreach ($tmp as $row)
					{
						$key = $row[$group_by];
						$result['details'][$key][] = $row;
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'C') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else if ($group_by==$rkey) {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
				break;	
				default:
					$tmp = $result['items'];
					$result['items'] = array();
					foreach ($tmp as $row)
					{
						$key = $row[$group_by];
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
					if(!empty($result['items']))
						$result['chart'] = $this->get_totals($data);

			}
		//}
		return $result; 
	}
	
	function total_with_diff_currency($result, $total_columns = array(), $fields = array()) 
	{
		/*$total = array();
		$display_total = array();
		$outstanding = array();
		foreach($result['items'] as $key=>$value) {
			$currency = $this->get_currency($result['items'][$key]['CC']);
			if(!empty($total_columns)) {
				foreach($value as $k=>$v) 
				{
					if(in_array($k,$total_columns)) 
					{
						if(isset($total[$value['CC']]) && isset($total[$value['CC']][$k])) 
							$total[$value['CC']][$k]['value']+= $v;
						else 	
							$total[$value['CC']][$k]['value'] = $v;
	
						if(!empty($fields)) {	
							if(in_array($k,$fields))
								$display_total[$value['CC']][$k] = ($total[$value['CC']][$k]['value']>0)?$currency . round($total[$value['CC']][$k]['value'],2):$currency . '0';
							else	
								$display_total[$value['CC']][$k] = $total[$value['CC']][$k]['value'];
						}
						else 
							$display_total[$value['CC']][$k] = ($total[$value['CC']][$k]['value']>0)?$currency . round($total[$value['CC']][$k]['value'],2):$currency . '0';
					}
				}
			}
			
			if(!empty($fields)) {
				foreach($fields as $k=>$v) {
					if(isset($result['items'][$key][$v])) {
						$result['items'][$key][$v] = $currency . round($result['items'][$key][$v],2);

					}
				}	
				foreach($total as $k=>$v) {
					$ot_amt = ($v[REP_INVOICE_AMOUNT]['value']+$v[REP_DEP_INV_AMOUNT]['value'])-($v[REP_PAYMENT_AMOUNT]['value']+$v[REP_PAY_AMOUNT]['value']);
					$outstanding[$result['items'][$key]['CC']] = $currency . $ot_amt;
				}
			}
			else {
				foreach($total_columns as $k=>$v) 
					if(isset($result['items'][$key][$v])) 
						$result['items'][$key][$v] = $currency . round($result['items'][$key][$v],2);
			}		
		}	
		$display_total = array_values($display_total);
		$result['total'] = $display_total;
		if(!empty($outstanding))
			$result['outstanding'] = array_values($outstanding);*/
		return $result;
	}

	function get_time_report_query($data, $select)
	{
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr', 'ts.entity_id=pr.entity_id and pr.project_id=ts.project_id');

		if (!empty($data['group_by']) && $data['group_by'] == REP_CLIENT || !empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'ts.entity_id=cl.entity_id and cl.client_id=pr.client_id');
		if (!empty($data['group_by']) && $data['group_by'] == REP_USER || !empty($select[REP_USER]))	
			$this->db->join('entity_users as eu', 'ts.entity_id=eu.entity_id and ts.user_id=eu.user_id');

		if (!empty($select['TA']))
			$this->db->join('project_task as pt', 'pt.entity_id=ts.entity_id and pt.task_id=ts.project_task_id', 'left');
		$this->db->join('task_type as ty', 'ts.entity_id=ty.entity_id and ts.task_type_id=ty.task_type_id','left');
		$this->db->join('project_task_types as pty', 'ty.entity_id=pty.entity_id and ty.task_type_id=pty.task_type_id AND pty.project_id = pr.project_id','left');
		$this->db->join('project_users as pru', 'ts.entity_id=pru.entity_id and ts.user_id=pru.user_id AND pr.project_id = pru.project_id','left');
		$this->db->where(array('ts.entity_id' => $this->ot_app->get('entity_id'), 'ts.hours >' => 0));

		return true;
	}

	function get_invoice_report_query($data, $select)
	{
		// Getting Invoice details
		if(isset($data['payment']))
			$invoice_fields = array(REP_CURRENCY_CODE, REP_CLIENT, REP_INVOICE_PERIOD, REP_PAYMENT_COUNT, REP_PAYMENT_AMOUNT, REP_PAY_COUNT, REP_PAY_AMOUNT);
		else
			$invoice_fields = array(REP_CURRENCY_CODE, REP_CLIENT, REP_INVOICE_PERIOD, REP_INVOICE_COUNT, REP_INVOICE_AMOUNT, REP_DEP_INV_COUNT, REP_DEP_INV_AMOUNT); 

		foreach($select as $key => $val) {
			if(in_array($key, $invoice_fields)) {
				$this->db->select($val[0], false);
			}	
		}
		$this->db->select('inv.invoice_id');
		$this->db->from('invoice as inv');
		if(isset($data['payment']))
			$this->db->join('invoice_payment as invp', 'inv.entity_id=invp.entity_id and inv.invoice_id=invp.invoice_id', 'LEFT');
		
		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'inv.entity_id=cl.entity_id and inv.client_id=cl.client_id');
 			
		$this->db->where(array('inv.entity_id' => $this->ot_app->get('entity_id')));
		
		if (empty($data['chart'])) {
			$group_by = !empty($data['group_by']) ? $data['group_by']:REP_INVOICE_PERIOD;
			$this->db->group_by($group_by);
			$this->db->order_by('inv.invoice_date');
		}
		return true;
	}
	
	function get_invoice_detail_report_query($data, $select)
	{
		$this->db->from('invoice as inv');
		
		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'inv.entity_id=cl.entity_id and inv.client_id=cl.client_id');
			
		if(!empty($data['params']['client_id']))
			$this->db->where('inv.client_id', $data['params']['client_id']);	
		
		if(!empty($data['params']['project_id'])) {
			$this->db->join('project as pr', 'inv.entity_id=pr.entity_id and inv.client_id=pr.client_id', 'LEFT');
			$this->db->where('pr.project_id', $data['params']['project_id']);
		}	

		if(!empty($select[REP_CLIENT_CONTACT]))
			$this->db->join('client_contact as clc', 'inv.entity_id=clc.entity_id and inv.client_contact_id=clc.client_contact_id and inv.client_id=clc.client_id');

		if(!empty($data['params']['currency_code']))
			 $this->db->where('inv.currency_code', $data['params']['currency_code']);
			 
		$this->db->where(array('inv.entity_id' => $this->ot_app->get('entity_id'))); 

		return true;
	}

	function get_invoice_aging_report_query($data, $select)
	{
		
		$interval = $data['interval'];
		
		$cur_date	= $this->auth->get_timezone_date('Y-m-d');
		// current date due_amount
		$sql = 'iv.client_id as CN, iv.currency_code as CC, concat(cl.client_code, cl.client_name) as CL';
		$sql.= ', SUM(case when iv.due_date="'.$cur_date.'" THEN iv.amount-iv.payment_amount ELSE 0 END) AS "CT"';
		
		$to_date = date('Y-m-d',strtotime('-1 day',strtotime($cur_date)));
		$from_date = date('Y-m-d',strtotime('-'.$interval.' day',strtotime($to_date)));		
		$sql .= ',SUM(case when iv.due_date BETWEEN "'.$from_date.'" AND "'.$to_date.'"THEN iv.amount-iv.payment_amount ELSE 0 END) AS "T1"';
		
		$to_date = date('Y-m-d',strtotime('-1 day',strtotime($from_date)));
		$from_date = date('Y-m-d',strtotime('-'.$interval.' day',strtotime($to_date)));	
		$sql .= ',SUM(case when iv.due_date BETWEEN "'.$from_date.'" AND "'.$to_date.'"THEN iv.amount-iv.payment_amount ELSE 0 END) AS "T2"';
	
		$from_date = date('Y-m-d',strtotime('-1 day',strtotime($from_date)));
		$sql .= ',SUM(case when iv.due_date<="'.$from_date.'" THEN iv.amount-iv.payment_amount ELSE 0 END) AS "T3"';
		
		$this->db->select($sql, false);
		$this->db->from('invoice as iv');		
		$this->db->join('client as cl', 'iv.entity_id=cl.entity_id and iv.client_id = cl.client_id');
		$this->db->where('iv.entity_id', $this->ot_app->get('entity_id'));
		if(isset($data['filters'][REP_CLIENT])) 
		{			
			$val = $data['filters'][REP_CLIENT];
			if (!is_array($val))
			{
				$this->db->where('iv.client_id', $val);
			} else if (!in_array('all', $val)) {
				$this->db->where_in('iv.client_id', $val);
			}
		}
		
		$this->db->where_in('iv.status', array('s', 'b'));
		$this->db->group_by('iv.client_id,iv.currency_code');
		
		return $this->db->get();
	}
	function get_invoice_outstanding_query($data, $select)
	{
		$this->db->select('inv.invoice_id, inv.currency_code as CC');
		$this->db->from('invoice as inv');
		
		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'inv.entity_id=cl.entity_id and inv.client_id=cl.client_id');
		
		$this->db->where('inv.entity_id', $this->ot_app->get('entity_id'));
		$cur_date	= $this->auth->get_timezone_date('Y-m-d');
		if(!empty($data['params']['aging_link'])) {
			$column = substr($data['params']['aging_link'],1,1);
			if($column>0 && $column<3) 
				$this->db->where('inv.due_date between DATE_ADD("'.$cur_date.'",INTERVAL ' . -(($column*$data['interval'])-1) . ' DAY) AND DATE_ADD("'.$cur_date.'",INTERVAL ' . -((($column-1)*$data['interval'])+1) . ' DAY)', null, FALSE);
			
			if($column==3)
				$this->db->where('(inv.due_date<DATE_ADD("'.$cur_date.'",INTERVAL -' . (($data['interval'] * 2)-1) . ' DAY))', null, FALSE);
								
			if($data['params']['aging_link']=='CT')
				$this->db->where('inv.due_date ="'.$cur_date.'"', null, FALSE);
			if($data['params']['aging_link']=='TL')
				$this->db->where('inv.due_date < "'.$cur_date.'"', null, FALSE);
		} else {
				$this->db->where('inv.due_date <= "'.$cur_date.'"', null, FALSE);
		}	
		if(!empty($data['params']['client_id']) && !empty($data['params']['currency_code'])) {
			$this->db->where('inv.client_id', $data['params']['client_id']);
			$this->db->where('inv.currency_code', $data['params']['currency_code']);
		}
		/*else
			$this->db->group_by('inv.client_id, inv.currency_code');*/

		$this->db->where("inv.status != 'd' and inv.status != 'p' ", NULL, FALSE);
		
		return true;
	}

	function get_invoice_uninvoiced_query($data, $select) 
	{
		if(isset($data['filters'][REP_CLIENT])) 
		{
			$where = '';
			$val = $data['filters'][REP_CLIENT];
			if (!is_array($val))
			{
				$where.=' and cl.client_id="' . $val . '"';
			} else if (!in_array('all', $val)) {
				$where.=' and cl.client_id in(' . implode(',',$val) . ')';
			}
		}
		$group_by = '';
		if(!empty($select[REP_CLIENT]) && !empty($select[REP_PROJECT]))
			$group_by = 'GROUP BY mt.project_id, pr.client_id';
		else {
			if(!empty($select[REP_CLIENT]))
				$group_by = 'GROUP BY pr.client_id';
			if(!empty($select[REP_PROJECT]))
				$group_by = 'GROUP BY mt.project_id';	
		}
		
		$from_date	= $data['filters']['from_date'];
		$to_date	= $data['filters']['to_date'];

		$query="SELECT c.budget_type, c.PD, c.CD, c.CL, c.PR, sum(c.CA) as CA, sum(c.CU) as CU, sum(c.EU) as EU, sum(c.EA) as EA, c.EA as UR, sum(c.EU) as UT FROM (
		
		(SELECT pr.budget_type, mt.project_id AS PD, cl.client_id AS CD, concat(cl.client_code, cl.client_name) AS CL, concat(pr.project_code, pr.project_name) AS PR, sum(mt.hours*mt.is_billable * (case mt.approval_status when 'A' then 1 else 0 end)) AS CA, 
		sum(mt.hours * mt.is_billable  * (case mt.approval_status when 'S' then 1 else 0 end)) AS CU, 0 AS EU, 0 AS EA, 0 as UR, 0 as UT
		FROM (ot_time_sheet as mt) JOIN ot_project as pr ON mt.project_id=pr.project_id JOIN ot_client as cl ON pr.client_id=cl.client_id
		WHERE mt.entity_id = '" . $this->ot_app->get('entity_id') . "'" . $where . " and mt.invoice_id<=0 and mt.approval_status!='' and mt.entry_date>='" . $from_date . "' and mt.entry_date<='" . $to_date . "' " . $group_by . ")
		
		UNION ALL(SELECT NULL as budget_type, mt.project_id AS PD, cl.client_id AS CD, concat(cl.client_code, cl.client_name) AS CL, concat(pr.project_code, pr.project_name) AS PR, 0 AS CA, 0 AS CU, sum(mt.amount * (!mt.approved_by )) AS EU, sum(mt.amount * (mt.approved_by/mt.approved_by)) AS EA, 0 as UR, 0 as UT
		FROM ot_project_expense as mt JOIN ot_project as pr ON mt.project_id = pr.project_id JOIN ot_client as cl ON pr.client_id=cl.client_id
		WHERE mt.entity_id = '" . $this->ot_app->get('entity_id') . "'" . $where . " and mt.invoice_id<=0 and mt.expense_date>='" . $from_date . "' and mt.expense_date<='" . $to_date . "' " . $group_by . ")) as c GROUP BY c.PD, c.CD";
//echo $query;
		return $query;
		
	}
	function get_unapproved_hours_detail_query($data, $select) 
	{
		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr', 'pr.project_id=ts.project_id');
		$this->db->join('task_type as ty', 'ty.task_type_id=ts.task_type_id');
		$this->db->join('entity_users as eu', 'eu.user_id=ts.user_id');
		$this->db->join('project_task_types as pty', 'pty.task_type_id=ty.task_type_id AND pty.project_id = pr.project_id');
		$this->db->join('project_users as pru', 'ts.user_id=pru.user_id AND pru.project_id = pr.project_id');
		$where = array('pr.project_id' => $data['params']['project_id'], 'pr.client_id' => $data['params']['client_id'], 'ts.entity_id' => $this->ot_app->get('entity_id'), 'ts.invoice_id <= '=>0, 'ts.approval_status !=' => '');
		$this->db->where($where);
		$this->db->group_by('ts.project_id');
	}
	function get_unapproved_expense_detail_query($data, $select) 
	{		
		$this->db->from('project_expense AS pre');
		$this->db->join('project AS pr','pr.project_id = pre.project_id');
		$this->db->where_in('pre.project_id', $data['params']['project_id']);
		$this->db->where(array('pre.entity_id' => $this->ot_app->get('entity_id'), 'pre.invoice_id'=> 0, 'pr.client_id' => $data['params']['client_id']));
		$this->db->join('expense_type AS ety', 'pr.entity_id = ety.entity_id AND ety.expense_type_id=pre.expense_type_id');
		$this->db->join('entity_users AS eu', 'eu.user_id = pre.created_by');
		$this->db->group_by('pr.project_id, pre.expense_type_id');
		return true;
	}
	function get_budget_query($data, $select) 
	{
		$this->db->from('project as pr');
		if (!empty($select[REP_TASK_FINISH_DATE]))
		{
			$this->db->join('time_sheet AS ts', 'pr.entity_id=ts.entity_id and pr.project_id=ts.project_id');
			$this->db->group_by('ts.project_id');
		}
		$this->db->join('client as cl', 'pr.client_id = cl.client_id');
		$this->db->where('pr.entity_id', $this->ot_app->get('entity_id'));
		$budget_type = !empty($data['budget_type'])?$data['budget_type']:'A';
		$this->db->where('pr.budget_type like("'.$budget_type.'%")');
		
		return true;
	}
	function get_budget_detail_query($data, $select)
	{
		$this->db->from('project_task_types as pty');
		$this->db->join('project as pr', 'pty.project_id=pr.project_id', 'INNER');
		$this->db->join('task_type as ty', 'pty.task_type_id=ty.task_type_id', 'INNER');
		$this->db->join('time_sheet AS ts', 'pty.task_type_id = ts.task_type_id AND pty.project_id = ts.project_id', 'left');
		// $this->db->join('project_task prt', 'prt.task_id=ts.project_task_id and prt.project_id=ts.project_id and prt.task_type_id=ts.task_type_id', 'left');
		$this->db->join('client as cl', 'pr.client_id = cl.client_id');
		$this->db->where(array('ty.entity_id' => $this->ot_app->get('entity_id')));
		$this->db->group_by('pty.project_task_type_id');
		$this->db->order_by('ty.sort_order');
		return true;
	}
	
	function get_task_detail_report_query($data, $select)
	{
		$this->db->from('project_task as pt');
		
		$this->db->join('time_sheet as ts', 'ts.project_Task_id=pt.task_id', 'LEFT');

		$where = array('pt.entity_id' => $this->ot_app->get('entity_id'), 'pt.is_parent !=' => 1);

		/*if (!empty($data[REP_PROJECT_TASK])) {
			$where['pt.task_id'] = $data[REP_PROJECT_TASK];
		} else {
			$where['pt.task_id >'] = 0;
		}*/
		$this->db->where($where);
		$this->db->join('project as pr', 'pr.project_id=pt.project_id');
		$this->db->join('task_type as ty', 'ty.entity_id = ts.entity_id and ty.task_type_id=ts.task_type_id','LEFT');
		$this->db->join('task_status as tt', 'tt.entity_id=pt.entity_id and tt.task_status_id=pt.task_status_id','LEFT');
		$this->db->join('entity_users as eu', 'ts.user_id=eu.user_id','LEFT');
		if (empty($data['chart'])) {
			$this->db->group_by('pt.task_id, ts.user_id, ts.entry_date');
		}
		$this->db->order_by('pt.task_id', 'desc');
		return true;
	}

	function get_task_report_query($data, $select)
	{
		$this->db->select('if (tt.is_closed=1 and tt.system_defined, 1, 0) AS is_closed', FALSE);
		$this->db->from('project_task as pt');
		
		$this->db->join('project as pr', 'pr.project_id=pt.project_id');

		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'cl.client_id=pr.client_id');

		$this->db->join('task_type as ty', 'pt.entity_id = ty.entity_id and pt.task_type_id=ty.task_type_id','LEFT');
		$this->db->join('task_status as tt', 'tt.entity_id=pt.entity_id and tt.task_status_id=pt.task_status_id','LEFT');
		$this->db->join('project_task_users as ptu', 'ptu.task_id=pt.task_id','LEFT');
		$this->db->join('entity_users as eu', 'eu.user_id=ptu.user_id','LEFT');
		$this->db->where(array('pt.entity_id' => $this->ot_app->get('entity_id'))); 
		$this->db->group_by('pt.task_id');
		$this->db->order_by('pt.task_id', 'desc');
		return true;
	}

	function get_expense_query($data, $select)
	{
		$this->db->from('project_expense as pe');
		$this->db->join('project as pr', 'pr.project_id=pe.project_id');
		
		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'cl.client_id=pr.client_id');
		if (!empty($select[REP_USER]))	
			$this->db->join('entity_users as eu', 'eu.user_id=pe.created_by');
			
		$this->db->join('expense_type as ey', 'ey.expense_type_id=pe.expense_type_id');
		$this->db->where(array('pe.entity_id' => $this->ot_app->get('entity_id')));

		return true;
	}
}
