<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Users_member extends CI_Model{

	public $error	= '';

	function __construct()
	{
		parent::__construct();
	}
	
	// 	Magic function return false
	public function __call($name, $arguments)
	{
	   //$this->response->error('INVALID_REQUEST', true);
	   return array();
	}
	
	public function update_mails($data)
	{
		$is_subscribed = empty($data['is_subscribed']) ? 0 : 1;
		$where	= array(
			'entity_id'	=> $data['entity_id'],
			'user_id'	=> $data['user_id'],
			'mail_type'	=> $data['mail_type']
		);

		if ($is_subscribed) {

			$query	= $this->db->select('user_mails_id, is_subscribed')->from('user_mails')->where($where)->get();
			$row	= $query->row_array();

			if (!$row) {
				$result	= $this->db->insert('user_mails', array(
					'entity_id'	=> $data['entity_id'],
					'user_id'	=> $data['user_id'],
					'mail_type'	=> $data['mail_type'],
					'is_subscribed'	=> $is_subscribed
				));
			}

			return $result ? true : false;
		}

		$this->db->where($where);
		$this->db->delete('user_mails');
		return true;
	}

	public function get_mail_subscription($user_id='')
	{
		$query	= $this->db->select('user_mails_id, mail_type, is_subscribed')->from('user_mails')->where(array(
			'user_id'	=> $user_id,
			'entity_id'	=> $this->ot_app->get('entity_id')
		))->get();
		$row	= $query->result_array();

		return $row;
	}

	public function save($data)
	{
		$this->load->library('entity_users_table');

		if(isset($data['user_image']) && $data['user_image']!='')
		{
			$url = str_replace('index.php','',site_url());
			$image = str_replace($url,'',$data['user_image']);
			$data['user_image']		= $image;
			$data['oldImage']		= $image;
		}

		$old_user_id = $data['user_id'];
		$user_id	= $this->entity_users_table->save($data);

		if (!$user_id)
		{
			return false;
		}
		$result = array();

		if($old_user_id == 0)
		{
			$result['is_edit_permission'] = false;
			if (is_pm($data['user_role']) || is_member($data['user_role']) || is_pmf($data['user_role']))
			{
				$result['is_edit_permission'] = true;
			}
		}

		$result['user_id'] = $user_id;
		return $result;
	}

	public function update($data)
	{
		if (empty($data['user_id']))
		{
			return false;
		}

//		$this->db->where('entity_id', $this->ot_app->get('entity_id'));
		$this->db->where('user_id', $data['user_id']);
		return $this->db->update('entity_users', $data);
	}

	public function get_profile_user($user_id = 0)
	{
		$user_id = intval($user_id);

		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('user_id, first_name, last_name, email, user_role, hourly_rate, user_image, department, time_zone_code, is_active');
		$this->db->from('entity_users');
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user_id));

		$query = $this->db->get();

		$data = $query->row_array();

		return $data;
	}
	public function get_projects($user_id = 0, $options = array()) 
	{
		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('pr.project_id, concat(pr.project_code, pr.project_name) AS project_name, pr.is_active, pr.created_date, pr.last_updated_date, concat(cl.client_code, cl.client_name) AS client_name, sum(ts.hours) as hours, max(ts.last_updated_date) as date', false);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$this->db->join('client as cl', 'pr.entity_id=cl.entity_id and pr.client_id=cl.client_id', 'INNER');
		$this->db->join('time_sheet as ts', 'pr.entity_id=ts.entity_id and pr.project_id=ts.project_id AND ts.user_id = '.$user_id.'', 'LEFT OUTER');		
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id' => $user_id));
		$this->db->group_by('pr.project_id');
		$this->db->order_by('date', 'desc');
		
		$from	= empty($options['from']) ? 0 : $options['from'];
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}

		$query = $this->db->get();

		$data = $query->result_array();

		return $data;
	}
	/*public function get_project_details($user_id, $pro_ids = array()) 
	{
		
		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('pr.project_id,sum(ts.hours) as hours, max(ts.last_updated_date) as date', false);
		$this->db->from('project as pr');
		$this->db->join('time_sheet as ts', 'pr.project_id=ts.project_id', 'INNER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'ts.user_id' => $user_id));
		$this->db->where_in('ts.project_id' , $pro_ids);
		$this->db->group_by('pr.project_id');
		$this->db->order_by('date', 'desc');

		$query = $this->db->get();

		$data = $query->result_array();

		return $data;
	}*/
	public function get_projects_count($user_id, $where = '') 
	{
		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('count(pr.project_id) as total_projects, sum(pr.is_active * 1) as active_projects', false);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id') , 'pru.user_id =' => $user_id));
		
		if(!empty($where)) {
			$this->db->where($where, NULL, FALSE);
		}
		
		$query = $this->db->get();

		return $query->row_array();
	}
	
	public function get_projects_hour ($user_id, $where = '') 
	{
		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('sum(ts.hours) as total_hours, sum(ts.hours * ts.is_billable) as billable', false);
		$this->db->from('project as pr');
		
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$this->db->join('time_sheet as ts', 'pr.entity_id=ts.entity_id and pr.project_id=ts.project_id', 'INNER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id') , 'pru.user_id =' => $user_id,'ts.user_id =' => $user_id));
		
		
		if(!empty($where)) {
			$this->db->where($where, NULL, FALSE);
		}
		
		$query = $this->db->get();

		return $query->row_array();	
	}
	public function have_add_permission()
	{
		return false;
	}
	public function get_users_with_hours (){
		$this->db->select('DISTINCT (user_id)', false);
		$this->db->from('ot_time_sheet');
		$this->db->where(array('entity_id'=> $this->ot_app->get('entity_id'), 'hours >' => 0));
		$this->db->group_by('user_id');
		$query = $this->db->get();

		$data = $query->result_array();

		return $data;
	}
}
