<?php	if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$this->load->library(OTBASE_PATH.'OT_User');
	$version	= $this->config->item('version');

	$plan	= $this->ot_app->get('plan');
?>
<!DOCTYPE html>
<html>
	<head>
		<link rel="icon" type="image/png" href="/favicon.png">
		<meta content="text/html;charset=utf-8" http-equiv="Content-Type">
		<meta content="utf-8" http-equiv="encoding">
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<?php
			$title = $this->ot_app->get('name') ? $this->ot_app->get('name').' ' : '';
			$title.= lang('OUTPUT_TIME');
		?>	
		<title><?php echo $title; ?></title>
	<!-- Bootstrap -->
	<?php
		$isLoggedIn	= (isset($this->ot_user) && $this->ot_user->get('user_id'));

		
		$css_pref	= 'assets/css/';
		$stylesheet	= array(
			'font-awesome/font-awesome.min.css',
			'bootstrap/bootstrap.min.css'
		);

		if ($isLoggedIn)
		{
// 			$stylesheet[]	= 'bootstrap/bootstrap-theme.css';
			$stylesheet[]	= 'bootstrap/bootstrap-theme.min.css';
		}
		$stylesheet[]	= 'index.php?v=' . OT_VERSION;

		$no_css_page	= array('signup', 'login', 'reset');
		if (!empty($stylesheet))
		{
			foreach ($stylesheet as $val)
			{
				stylesheet($css_pref . $val);
			}
		}

		$js_pref	= 'assets/js/';
		if ($isLoggedIn)
		{
//			javascript($pref . 'index.php?type=pre');
//			javascript($pref . 'index.php?type=post');
			$javascript	= array(
				'jquery/jquery-1.8.2.min.js',
				'knockout/knockout-2.2.0.js',
				'index.php?type=a&v=' . OT_VERSION,
				'index.php?type=post&v=' . OT_VERSION,
				'index.php?type=output&v=' . OT_VERSION
			);
		}
		else
		{
//			javascript($pref . 'index.php?type=login');
			$javascript	= array(
				'jquery/jquery-1.8.2.min.js',
				'knockout/knockout-2.2.0.js',
				'knockout/knockout.validation.min.js',
				'bootstarp/bootstrap.min.js',
				'index.php?type=b&v=' . OT_VERSION
			);
		}

		if (!empty($javascript))
		{
			foreach ($javascript as $val)
			{
				javascript($js_pref . $val);
			}
		}
	?>
<?php /*
	<script>
		(function(i,s,o,g){var r = 'ODL';i[r]=i[r]||function(){(i[r].prop=i[r].prop||[]).push(arguments);};a=s.createElement(o),m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)})(window,document,'script','http://ec2-54-85-108-47.compute-1.amazonaws.com:8081/js/frontend/odl.js');
	</script>
*/ ?>
	<!--[if lte IE 10]>
		<?php stylesheet($css_pref . 'ie.css'); ?>
		<?php //javascript($js_pref . 'plugin/placeholder.min.js'); ?>
	<![endif]-->
	</head>
	<?php
		$file			= pathinfo($this->ot_app->get('entity_logo'));
		$entity_logo	= null; // !empty($file['extension'])?base_url() . 'uploads/' . $this->ot_app->get('entity_id') . '/' . $file['filename'] . '_50.' . $file['extension']:'#';
	?>
	<body class="<?php echo $this->ot_app->get('entity_id')?'header-fixed':''; ?>">
<?php if ($this->ot_app->get('entity_id')) { ?>
		<div role="banner" class="header">
			<div class="container">
				<div class="navbar-header pull-left col-md-7">
					<?php if ($entity_logo): ?>
						<img src="<?php echo $entity_logo; ?>" height="32" style="margin-top: 5px; margin-right: 5px;" class="pull-left" />
					<?php endif; ?>
					<?php if ($this->uri->segment(1)=='register') {?>
						<a class="dib navbar-brand " href="#" style="font-size:20px;"><?php echo lang('OUTPUT_TIME'); ?></a>
					<?php } else {?>
						<a class="dib navbar-brand " href="./"><?php echo lang('OUTPUT_TIME'); ?></a>
						<span class="dib navbar-brand company-name" id="company-name" style="font-size:15px;"> - <?php echo $this->ot_app->get('name'); ?></span>
					<?php } if ($this->ot_app->get('plan')=='F') { ?>
						<a class="btn btn-md btn-warning" href="http://www.outputtime.com/index.php/output-time-pricing/" role="button" target="_blank" style="margin:2px 20px 0px">Upgrade</a>
					<?php } else  if ($this->ot_app->get('plan')) {
						$diff = round((strtotime($this->ot_app->get('exp_date')) - strtotime($this->auth->get_timezone_date('Y-m-d')))/86400);

						$notice = "";
						switch ($diff) {
							case 0:
								$notice = '<div class="pull-right alert alert-danger" role="alert" style="padding: 9px;">'.lang($this->ot_app->get('plan').'_EXPIRED_TODAY').'</div>';
							break;
							case 1:
								$notice = '<div class="pull-right alert alert-danger" role="alert" style="padding: 9px;">'.lang($this->ot_app->get('plan').'_EXPIRED_TOMORROW').'</div>';
								break;
							default:
								if ($diff > 1  && $diff<=7) {
									$notice = '<div class="pull-right alert alert-warning" role="alert" style="padding: 9px;">'.sprintf(lang($this->ot_app->get('plan').'_EXPIRED_DAYS'),$diff,date('M j,Y',strtotime($this->ot_app->get('exp_date')))).'</div>';
								}
						}
						echo $notice;
					}
					$lic_msg = $this->session->flashdata('lic_msg');

					if ($lic_msg) {
						$msg = $this->session->flashdata('lic_success')?'<div class="pull-right alert alert-success" role="alert" style="padding: 9px;">':'<div class="pull-right alert alert-danger" role="alert" style="padding: 9px;"><button data-dismiss="alert" class="close" type="button">×</button>';
						$lic_msg = $msg.$lic_msg.'</div>';
						
					}
					if ($lic_msg) {
						echo $lic_msg;
					}
?>
					<div id="score"></div>
					<span id="loader"></span>
				</div>
				<div class="dib pull-right">
				<?php
					if ($isLoggedIn)
					{
						$userImg	= base_url()."/files/photo/no-User.png";
						if($this->ot_user->get('user_image'))
						{
							$userImg	= base_url() . 'uploads/' . $this->ot_app->get('entity_id') . '/prof/' . '38/' . $this->ot_user->get('user_image');
						}
				?>
					<div class="pr pull-left" id="active-task">
					<?php $this->load->view('progress'); ?>
					</div>
					<div class="dropdown navbar-right user-info">					
						<div class="dib pr"><?php /*
							<a class="pull-left notify" id="notify" href="javascript:;" title="Notification">
								<span class="count h4"></span>
								<i class="icon-metro icon-bell img-circle"></i>
							</a>
							<div id="notify-cont" style="width:auto;right:0px;" class="fs-13">
								<ul id="notify-list" class="dib dropdown-menu list-unstyled">
								</ul>
							</div>
							*/ ?><a class="pull-left book-mark" id="bookmark" href="javascript:;" title="Bookmark Report">
								<i class="icon-metro icon-bookmark img-circle"></i>
							</a><?php $this->load->view('bookmark'); ?>
						</div>
						<div class="dib pr">
							<a class="dropdown-toggle" href="javascript:;" data-toggle="dropdown">
								<div class="user-photo">
									<img class="img40x40" fnt-size="25px" style="font-size: 28px;" src="<?php echo $userImg; ?>" onError="onImageError(this);" title="<?php echo $this->ot_user->get('first_name'); ?>" style="max-width:38px;">
								</div>
								<div class="user-name" style="margin-right:20px;">
									<?php echo $this->ot_user->get('first_name').' '.$this->ot_user->get('last_name');?>
								</div>
								<span class="icon-caret-down icon-white dib" style="margin-top:14px;"></span>
							</a>
							<ul class="dropdown-menu">
								<li><a href="<?php echo site_url('profile');?>"><?php echo lang('EDIT_PROFILE'); ?></a></li>
								<li class="divider"></li>								
								<li><a href="<?php echo site_url('user/logout');?>"><?php echo lang('LOGOFF'); ?></a></li>
						 	 </ul>
					 	 </div>
					 	 <div class="dib pr">
						 	 <button data-target="#mobile-menu-navbar-collapse" data-toggle="collapse" type="button" class="navbar-toggle collapsed">
								<span class="sr-only"><?php echo lang('TOGGLE_NAVIGATION'); ?></span>
								<span class="icon-bar"></span>
								<span class="icon-bar"></span>
								<span class="icon-bar"></span>
							</button>
					 	 </div>
					</div>
			 	<?php } ?>
			 	</div>
			</div>
		</div>
<?php } ?>
		<div class="page-container" style="clear:both">
			<div id="project-popover"  style="width: 100%; height: 100%; top: 0px; left: 0px; z-index: 100; position: fixed; background-color:rgba(0, 0, 0, 0.3);display:none;">
				<div class="popover pa" style="height: 150px; width: 350px; display: block; top: 40%; left: 40%;">
					<div class="arrow"></div>
					<h3 class="popover-title" style="">
						<span id="pop_title"><?php echo lang('TRACK_YOUR_TIME'); ?></span>
					</h3>
					<div class="popover-content ">
						<span id="pop_desc"></span><br><br>
						<a href="<?php echo site_url('project/add');?>" id="add_project" class="btn btn-primary pull-right col-md-6"><span class="pull-left b">Project</span><i class="icon icon-plus pull-right icon-white" style="padding-top: 3px"></i></a>
					</div>
				</div>
			</div>
			<!-- page-container -->
			<?php
			if ($isLoggedIn)
			{
				$this->load->view("leftshortcut", array('plan'=>$plan));
// 				if ($plan == 'P')
// 				{
// 					$this->load->view("chat_tmpl");
// 				}
			}
		 	?>
		 	<div class="page-content container auto-height <?php  echo $isLoggedIn?'main-right':'';?>" id="main-container">
		 		<div id="ajax_loader_image" class="pull-left"></div>
	 		<!-- page-content -->
