<?php	if ( ! defined('BASEPATH')) exit('No direct script access allowed');

?>
<div class="col-md-12 pr task_type dib np" data-bind="with:task_types">
	<!-- ko if:parent().is_new_mode() == false -->
	<div class="btn-save-ctl pull-right">
		<button id="edit" class="btn btn-sm edit vh" data-bind="hidden:is_edit_mode, click:edit">
			<i class="icon-pencil">&nbsp;</i><?php echo lang('EDIT'); ?>
		</button>
		<div class="btn-group" data-bind="visible:is_edit_mode">
			<button class="btn btn-sm btn-success" id="save" data-bind="click:save">
				<i class="icon-save icon-white">&nbsp;</i><?php echo lang('SAVE'); ?>
			</button>
			<button class="btn btn-sm btn-primary" id="cancel" data-bind="click:cancel">
				<i class="icon-remove-sign icon-white">&nbsp;</i>
			</button>
		</div>
	</div>
	<!-- /ko -->
	<div class="content no-padding no-margin table-responsive">
		<table cellpadding="0" cellspacing="0" class="table task_type_table col-lg-11 col-md-11" data-bind="css : { 'table-striped' : is_edit_mode()==false}">
			<thead>
				<tr>
					<th class="al col-lg-4"><?php echo lang('Task Type'); ?></th>
					<!-- ko if:($root.user_role()=='A' || $root.user_role()=='F') && ($root.budget().budget_type()=='AT' || $root.invoice.invoice_type()=='T')-->
					<th class="col-lg-3 nowrap ar">
						<?php echo lang('HOURLY_RATE'); ?>(<?php echo CURRENCY; ?>)
					</th>
					<!-- /ko -->
					<!-- ko if:$root.budget().budget_type()!='HP' && $root.budget().budget_type()!='AP' -->
					<th class="col-lg-2 nowrap ar"><?php echo lang('ESTIMATED'); ?>(<?php echo lang('HRS'); ?>)</th>
					<!-- /ko -->
					<!-- ko ifnot:is_edit_mode -->
					<th class="col-lg-2 nowrap ar"><?php echo lang('ACTUAL'); ?>(<?php echo lang('HRS'); ?>)</th>
					<!-- /ko -->
					<th class="col-lg-1 nowrap text-center">&nbsp;&nbsp;&nbsp;&nbsp;</th>
				</tr>
			</thead>
			<!-- ko ifnot:is_edit_mode -->
			<tbody class="editable" data-bind="foreach:items">
				<tr>
					<td class="" data-bind="text:name_lbl"></td>
					<!-- ko if:($root.user_role()=='A' || $root.user_role()=='F') && ($root.budget().budget_type()=='AT' || $root.invoice.invoice_type()=='T') -->
					<td class="ar" data-bind="text:hourly_rate"></td>
					<!-- /ko -->
					<!-- ko if:$root.budget().budget_type()!='HP' && $root.budget().budget_type()!='AP' -->
					<td class="ar" data-bind="hours:{val:estimated_hours}"></td>
					<!-- /ko -->
					<td class="ar" data-bind="hours:{val:actual_hours}"></td>
					<td >&nbsp;</td>
				</tr>
			</tbody>
			<!-- /ko -->
			<!-- ko if:is_edit_mode -->
			<tbody class="editable" data-bind="foreach:items">
				<tr class="box-condensed dbr">
					<td class="dash-border-left dash-border-top ">
						<select class="form-control input-sm no-border" id="task_types_list" data-bind="options:task_types_list, event:{blur:function(data, event){$parent.addNew($index, data)}}, optionsText:'name', optionsValue:'task_type_id', value:task_type_id, optionsCaption: 'Select any task type...'"></select>
					</td>
					<!-- ko if:($root.user_role()=='A' || $root.user_role()=='F') && ($root.budget().budget_type()=='AT' || $root.invoice.invoice_type()=='T') -->
					<td class="dash-border-left dash-border-top dbr ar">
						<input type="text" data-bind="value:hourly_rate, numberOnly:true" maxlength="5" class="no-bg ar col-md-12">
					</td>
					<!-- /ko -->
					<!-- ko if:$root.budget().budget_type()!='HP' && $root.budget().budget_type()!='AP' -->
					<td class="dash-border-left dash-border-top dbr ar">
						<input type="text" data-bind="value:estimated_hours, numberOnly:true" maxlength="5" class="no-bg ar col-md-12">
					</td>
					<!-- /ko -->
					<td class="dash-border-top text-center vam nbl">
						<span class="delete cp" id="delete" data-bind="click:$parent.removeItem,style: { visibility: task_type_id() ? 'visible' : 'hidden' }" ><i class="icon-remove"></i></span>
					</td>
				</tr>
			</tbody>
			<!-- /ko -->
			<tfoot class="bold">
				<tr>
					<td class="col-lg-2 npt npb vam"><h5><?php echo lang('TOTAL'); ?></h5></td>
					<!-- ko if:($root.user_role()=='A' || $root.user_role()=='F') && ($root.budget().budget_type()=='AT' || $root.invoice.invoice_type()=='T') -->
					<td class="col-lg-2 npt npb vam">&nbsp;</td>
					<!-- /ko -->
					<!-- ko if:$root.budget().budget_type()!='HP' && $root.budget().budget_type()!='AP' -->
					<td class="col-lg-2 ar npt npb vam">
						<h4 class="dib" data-bind="hours:{val:eht}"></h4>
						<!-- ko if:$root.user_role()=='A' || $root.user_role()=='F' -->
						<h4 class="nm" data-bind="currency:{val:ehta, symbol:'<?php echo CURRENCY; ?>'}"></h4>
						<!-- /ko -->
					</td>
					<!-- /ko -->
					<!--  ko ifnot:is_edit_mode -->
					<td class="col-lg-2 ar npt npb vam">
						<h4 class="dib" data-bind="hours:{val:aht}"></h4>
						<!-- ko if:$root.user_role()=='A' || $root.user_role()=='F' -->
						<h4 class="nm" data-bind="currency:{val:ahta, symbol:'<?php echo CURRENCY; ?>'}"></h4>
						<!-- /ko -->
					</td>
					<!-- /ko -->
					<td class="col-lg-2 text-center npt npb vam"></td>
				</tr>
			</tfoot>
		</table>
	</div>
</div>
<div class="clearfix"></div>
